package mct;


/**
 *@(#)Console.java        Gatot Susilo    September 4, 1997
 */
/**************************************************************************
 *                    COPYRIGHT of MOBILE CODE TOOLKIT                    *
 *                                                                        *
 * This program is a free software and follows terms and conditions as    *
 * described on the GNU General Public License                            *
 * (see http://www.sce.carleton.ca/netmanage/gatot/gpl.html).             *
 * This software is freely distributed; however we recommend that         *
 * everybody should download a free copy directly from our site           *
 * http://www.sce.carleton.ca/netmanage/gatot.                            *
 * Therefore, we can keep a track who has got a copy and what for what    *
 * the purpose is. This will allow us to notify you when there are changes* 
 * or bugs fixed on the next release.                                     *                                   
 *                                                                        *
 * This program is a part of work in the Perpetuum Mobile Procura project.*
 * URL: http://www.sce.carleton.ca/netmanage/perpetuum.shtml.             *
 *                                                                        * 
 * Copyright 1997, Gatot Susilo                                           *
 * Department of Systems and Computer Engineering,                        *
 * Carleton University                                                    *
 *                                                                        *
 * Author: Gatot Susilo (susilo@sce.carleton.ca)                          *  
 * Date: October 5, 1997                                                  *
 * Contact Person:                                                        *
 *  Andrzej Bieszczad, Associate Professor, Systems & Computer Engineering*
 *  1125 Colonel By Drive, Carleton University, Ottawa, Canada K1S 5B6    *
 *  Email: andrzej@sce.carleton.ca    Tel:(613)520-5734  Fax:(613)520-5727*
 *  URL: http://www.sce.carleton.ca/faculty/bieszczad.html                *
 **************************************************************************
 *                                NO WARRANTY                             *
 *                                                                        *
 * BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY   *
 * FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN*
 * OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES *
 * PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER       *
 * EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED       *
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE*
 * ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH   *
 * YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL    *
 * NECESSARY SERVICING, REPAIR OR CORRECTION.                             *
 *                                                                        *    
 * IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING  *
 * WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR    *
 * REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR      *
 * DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL   *
 * DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM         *
 * (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED      *
 * INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF *
 * THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER OR*
 * OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 **************************************************************************/
import java.io.*;

/**
 * This class is used to write to standard output for any message
 * from classes.
 */
public class Console {
	private static boolean debugFlag = false;
	private static boolean errorFlag = true;
	private static boolean messageFlag = true;
	private static boolean warningFlag = true;
	private static boolean applicationFlag = false;
	private static boolean infoFlag = false;
	private static PrintStream pStream = System.out;



public static void application(Object clazz, String message) {
	if (!applicationFlag || pStream == null)
		return;
	if (clazz != null)
		pStream.println("APPLICATION: " + clazz.getClass().getName() + ": " + message);
	else
		pStream.println("APPLICATION: " + message);
}
public static void debug(Object clazz, String message) {
	if (!debugFlag || pStream == null)
		return;
	if (clazz != null)
		pStream.println("DEBUG: " + clazz.getClass().getName() + ": " + message);
	else
		pStream.println("DEBUG: " + message);
}
public static void error(Object clazz, String message) {
	if (!errorFlag || pStream == null)
		return;
	if (clazz != null)
		pStream.println("ERROR: " + clazz.getClass().getName() + ": " + message);
	else
		pStream.println("ERROR: " + message);
}
public static void info(Object clazz, String message) {
	if (!infoFlag || pStream == null)
		return;
	if (clazz != null)
		pStream.println("INFO: " + clazz.getClass().getName() + ": " + message);
	else
		pStream.println("INFO: " + message);
}
public static void message(Object clazz, String message) {
	if (!messageFlag || pStream == null)
		return;
	if (clazz != null)
		pStream.println("MESSAGE: " + clazz.getClass().getName() + ": " + message);
	else
		pStream.println("MESSAGE: " + message);
}
/**
 * This method was created by a SmartGuide.
 * @return boolean
 * @param on boolean
 */
public static boolean setConsole(boolean on) {
	if (on)
		pStream = System.out;
	else
		pStream = null;
	return pStream == null;
}
/**
 * This method was created by a SmartGuide.
 * @param debug boolean
 * @param error boolean
 * @param message boolean
 * @param warning boolean
 * @param application boolean
 * @param info boolean
 */
public static void setFlags(boolean debug, boolean error, boolean message, boolean warning, boolean application, boolean info) {
	debugFlag = debug;
	errorFlag = error;
	messageFlag = message;
	warningFlag = warning;
	applicationFlag = application;
	infoFlag = info;
	return;
}
public static void warning(Object clazz, String message) {
	if (!warningFlag || pStream == null)
		return;
	if (clazz != null)
		pStream.println("WARNING: " + clazz.getClass().getName() + ": " + message);
	else
		pStream.println("WARNING: " + message);
}
}