package mct.admin;


/**
 * This class was generated by a SmartGuide.
 * 
 */
import java.util.Hashtable;
import java.net.URL;
import java.security.*;
import mct.security.MobileCodeVerifier;
public class MCTNetworkClassLoader extends ClassLoader {
	private Hashtable cache = null;
	private String authority = null;
	private URL codebase = null;
	private Hashtable byteCodes = null;
	private MobileCodeContainer mcc = null;
	private boolean byPassVerifier = true;
	private IdentityScope identityScope = IdentityScope.getSystemScope();
	private MobileCodeVerifier mcv = null;
	private MigrationInterface mf = null;



/**
 * MCTNetworkClassLoader constructor comment.
 * @param name java.lang.String
 */
public MCTNetworkClassLoader(String name) {
	cache = new Hashtable();
	byteCodes = new Hashtable();
	authority = name;
}
/**
 * This method was created in VisualAge.
 * @param authority java.lang.String
 * @param cache java.util.Hashtable
 * @param byteCodes java.util.Hashtable
 * @param codebase java.net.URL
 * @param mf mct.admin.MigrationInterface
 * @param byPassVerifier boolean
 */
private MCTNetworkClassLoader(String authority, Hashtable cache, Hashtable byteCodes, URL codebase, MigrationInterface mf, boolean byPassVerifier) {
	this.codebase = codebase;
	this.authority = authority;
	this.cache = cache;
	this.byteCodes = byteCodes;
	this.mf = mf;
	this.byPassVerifier = byPassVerifier;
}
/**
 * This method was created by a SmartGuide.
 * @param name java.lang.String
 * @param passVerifier boolean
 */
public MCTNetworkClassLoader(String name, boolean passVerifier) {
	cache = new Hashtable();
	byteCodes = new Hashtable();
	authority = name;
	byPassVerifier = passVerifier;
}
/**
 * Return a clone of the class loader. Note that the hashtables are not cloned; this is
 * a deliberate act in order to have the clones access and use the same storage.
 *
 * @return java.lang.Object
 */
public Object clone() {
	return new MCTNetworkClassLoader(authority, cache, byteCodes, codebase, mf, byPassVerifier);
}
/**
 * This method was created by a SmartGuide.
 * @return byte[]
 * @param className java.lang.String
 */
public byte[] getByteCodes(String className) {
	return (byte[]) byteCodes.get(className);
}
/**
 * This method was created by a SmartGuide.
 * return mct.admin.MigrationInterface
 */
public MigrationInterface getMigrationFacilitator() {
	return mf;
}
/**
 * This method was created by a SmartGuide.
 */
public MobileCodeContainer getMobileCodeContainer() {
	return mcc;
}
/**
   * First of all, find the class in the system and then
   * find the class in the MobileCodeContainer.<p>
   *
   * You may change the order of the search if you want to
   * make that your classes in the MobileCodeContainer are precendence
   * to ones in the system. <p>
   *
   * @see#ClassLoader class for further detail.
   *
   */
public synchronized Class loadClass(String name, boolean resolve) throws ClassNotFoundException {
	Class c = (Class) cache.get(name);
	if (c == null) {
		byte[] classBytes = null;
		try {
			c = findSystemClass(name);
		} catch (ClassNotFoundException ex) {
			if (name.startsWith("java."))
				throw new ClassNotFoundException();
			if (name.startsWith("sun."))
				throw new ClassNotFoundException();
			if (mf == null) {
				try {
					mf = (MigrationInterface) java.rmi.Naming.lookup("//" + codebase.getHost() + codebase.getFile());
				} catch (Exception nex) {
					throw new ClassNotFoundException("could not locate " + codebase+"\nReason: "+nex);
				}
			}
			byte[] jarBytes = null;
			try {
				jarBytes = mf.transfer(name, authority);
				mcc.addJar(name, jarBytes);
				classBytes = verifyJar(name);
			} catch (Exception nex) {
				throw new ClassNotFoundException("could not transfer " + name + " authority " + authority + "\nReason: " + nex);
			}
			if ((classBytes != null) && (classBytes.length > 0)) {
				c = defineClass(null, classBytes, 0, classBytes.length);
				cache.put(name, c);
				byteCodes.put(name, jarBytes);
			} else {
				throw new ClassNotFoundException("Illegal class definition for " + name + " authority " + authority);
			}
		}
	}
	if (resolve)
		resolveClass(c);
	return c;
}
/**
 * This method was created by a SmartGuide.
 * @return byte[]
 * @param className java.lang.String
 * @param classByteCodes byte[]
 */
public void setByteCodesForClass(String className, byte[] classByteCode) {
	byteCodes.put(className, classByteCode);
}
/**
 * Set up the codebase for resolution of missing class code.
 * If it has not changed from this to the last, don't bother 
 * to reset the migration facilitator object. This is meant
 * to avoid unnecessary lookup in the RMI registry.
 * @return URL
 * @param codebase URL
 */
public void setCodeBase(URL codebase) {
	if (this.codebase != null && this.codebase.equals(codebase))
		return;
	mf = null;
	this.codebase = codebase;
}
/**
 * This method was created by a SmartGuide.
 * @param mf mct.admin.MigrationInterface
 */
public void setMigrationFacilitator(MigrationInterface mf) {
	this.mf = mf;
}
/**
 * Create a temporary verifier for this container
 * @param mcc mct.admin.MobileCodeContainer
 */
public void setMobileCodeContainer(MobileCodeContainer mcc) {
	this.mcc = mcc;
	this.mcv = new MobileCodeVerifier(mcc, identityScope);
}
/**
   * Verify the MobileCodeContainer. If you modify the content (JARs) of 
   * MobileCodeContainer, this method should be called to verify the
   * modified content. The modifiable content (JAR) will be verified
   * and inflated into number of classes that comprise it.
   */
public byte[] verifyJar(String jarName) throws java.io.IOException {
	return mcv.verifyJar(jarName, byPassVerifier);
}
}