package mct.admin;


/**
 * This class was generated by a SmartGuide.
 * 
 */
import mct.users.MobileCodeObject;
public class MCThreadExceptionHandler implements mct.admin.ExceptionHandler {
	private MobileCodeManager mcm = null;
	private StorageManager sm = null;



/**
 * Create the exception handler with a knowledge of both the
 * mobile code and storage managers. The storage manager isn't 
 * strictly required for the handler but is present for future
 * considerations.
 * @param mcm mct.admin.MobileCodeManager
 * @param sm mct.admin.StorageManager
 */
public MCThreadExceptionHandler(MobileCodeManager mcm, StorageManager sm) {
	this.mcm = mcm;
	this.sm = sm;
}
/**
 * onException is called when an exception has been thrown for
 * the receiver.
 */
public boolean onException(mct.users.Receiver receiver, Exception exception) {
	if (receiver.getObject() instanceof MobileCodeObject) {
		MobileCodeStatus mcs = mcm.getMobileCodeStatus((MobileCodeObject)receiver.getObject());
		if (mcs != null)
			mcs.beGarbageCollectable();		
	}
	return false;
}
/**
 * onExit is used in order to ensure that we tidy up when a thread 
 * exits. We ensure that the status record "forgets" about the thread
 * and we attempt to garbage collect information for the mobile agent.
 *
 * @return boolean true if instance was a mobile agent, false otherwise
 * @param receiver mct.users.Receiver the agent running in thread.
 */
public boolean onExit(mct.users.Receiver receiver) {
	if (receiver.getObject() instanceof MobileCodeObject) {
		MobileCodeStatus mcs = mcm.getMobileCodeStatus((MobileCodeObject) receiver.getObject());
		if (mcs != null)
			mcs.setThread(null);
		mcm.garbageCollect((MobileCodeObject) receiver.getObject());
		return true;
	}
	return false;
}
}