package mct.admin;


/**
 * @(#)MethodRunnerThread	24-Aug-98	Tony White
 */
/**************************************************************************
 *                    COPYRIGHT of MOBILE CODE TOOLKIT                    *
 *                                                                        *
 * This program is a free software and follows terms and conditions as    *
 * described on the GNU General Public License                            *
 * (see http://www.sce.carleton.ca/netmanage/gatot/gpl.html).             *
 * This software is freely distributed; however we recommend that         *
 * everybody should download a free copy directly from our site           *
 * http://www.sce.carleton.ca/netmanage/gatot.                            *
 * Therefore, we can keep a track who has got a copy and what for what    *
 * the purpose is. This will allow us to notify you when there are changes* 
 * or bugs fixed on the next release.                                     *                                   
 *                                                                        *
 * This program is a part of work in the Perpetuum Mobile Procura project.*
 * URL: http://www.sce.carleton.ca/netmanage/perpetuum.shtml.             *
 *                                                                        * 
 * Copyright 1997, Gatot Susilo                                           *
 * Department of Systems and Computer Engineering,                        *
 * Carleton University                                                    *
 *                                                                        *
 * Author: Gatot Susilo (susilo@sce.carleton.ca)                          *  
 * Date: October 5, 1997                                                  *
 * Contact Person:                                                        *
 *  Andrzej Bieszczad, Associate Professor, Systems & Computer Engineering*
 *  1125 Colonel By Drive, Carleton University, Ottawa, Canada K1S 5B6    *
 *  Email: andrzej@sce.carleton.ca    Tel:(613)520-5734  Fax:(613)520-5727*
 *  URL: http://www.sce.carleton.ca/faculty/bieszczad.html                *
 **************************************************************************
 *                                NO WARRANTY                             *
 *                                                                        *
 * BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY   *
 * FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN*
 * OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES *
 * PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER       *
 * EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED       *
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE*
 * ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH   *
 * YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL    *
 * NECESSARY SERVICING, REPAIR OR CORRECTION.                             *
 *                                                                        *    
 * IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING  *
 * WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR    *
 * REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR      *
 * DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL   *
 * DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM         *
 * (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED      *
 * INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF *
 * THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER OR*
 * OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 **************************************************************************/

import java.util.Vector;
import java.util.Enumeration;
import java.util.Properties;
import mct.users.Receiver;
public class MethodRunnerThread extends Thread {
	private Receiver receiver;
	private Object[] parameters;
	private ExceptionHandler exceptionHandler;



/**
 * This method was created by a SmartGuide.
 * This version of the constructor assumes that the user has correctly
 * identified the method object. However, it is more dangerous to use
 * when compared to the other, more general, constructors.
 *
 * @param object java.lang.Object
 * @param method java.lang.reflect.Method
 * @param parameters java.lang.Object[]
 * @param handler java.lang.Object
 */
public MethodRunnerThread(Object object, java.lang.reflect.Method method, Object[] parameters, ExceptionHandler handler) {
	super(object.toString() + "->" + method.getName());
	this.receiver = new Receiver(object, method);
	this.parameters = parameters;
	this.exceptionHandler = handler;
	start();
}
/**
 * This method was created by a SmartGuide.
 * @param object java.lang.Object
 * @param methodName java.lang.String
 * @param parameters java.lang.Object[]
 * @param handler java.lang.Object
 */
public MethodRunnerThread(Object object, String methodName, Object[] parameters, ExceptionHandler handler) {
	super(object.toString() + "->" + methodName);
	Class[] parameterTypes = new Class[parameters.length];
	for (int i = 0; i < parameters.length; i++)
		parameterTypes[i] = parameters[i].getClass();
	this.receiver = new Receiver(object, methodName, parameterTypes);
	this.parameters = parameters;
	this.exceptionHandler = handler;
	start();
}
public MethodRunnerThread(Object object, String methodName, Object[] parameters, ExceptionHandler handler, ThreadGroup threadGroup) {
	super(threadGroup, object.toString() + "->" + methodName);
	Class[] parameterTypes = new Class[parameters.length];
	for (int i = 0; i < parameters.length; i++)
		parameterTypes[i] = parameters[i].getClass();
	this.receiver = new Receiver(object, methodName, parameterTypes);
	this.parameters = parameters;
	this.exceptionHandler = handler;
	start();
}
// Invoke the method on the object. Use this thread to do it though.
public void run() {
	try {
		receiver.invoke(parameters);
	} catch (java.lang.IllegalAccessException ex) {
		if (exceptionHandler instanceof ExceptionHandler)
			exceptionHandler.onException(receiver, ex);
		mct.Console.warning(null, ex.toString());
	} catch (java.lang.reflect.InvocationTargetException ex) {
		if (!(ex.getTargetException() instanceof java.lang.ThreadDeath)) {
			mct.Console.warning(null, ex.toString());
			ex.getTargetException().printStackTrace();
			if (exceptionHandler instanceof ExceptionHandler)
				exceptionHandler.onException(receiver, ex);
		} else
			// Should throw it for cleanup of threads
			try {
			throw ex.getTargetException();
		} catch (Throwable tex) {
		};
	} finally {
		if (exceptionHandler instanceof ExceptionHandler)
			exceptionHandler.onExit(receiver);
	}
}
}