package mct.admin;


/**
 * @(#)MigrationInterface.java 23 Sep 98 Tony White
 * This interface defines the protocol for interaction with
 * an RMI-based migration facility.
 * 
 */
import mct.users.MCIdentifier;
import java.rmi.RemoteException;
import java.util.BitSet;
public interface MigrationInterface extends java.rmi.Remote {



/**
 * This method is intended to send an agent from one MCD to 
 * another. If state is null it means that a new instance of the
 * agent should be created.
 * @return boolean
 * @param id MCIdentifier
 * @param state byte[]
 * @param location java.net.URL
 */
public boolean send(MCIdentifier id, byte[] state, java.net.URL location) throws RemoteException;
/**
 * This method is intended to send an agent from one MCD to 
 * another. If state is null it means that a new instance of the
 * agent should be created.
 * @return boolean
 * @param id MCIdentifier
 * @param location java.net.URL
 */
public boolean send(MCIdentifier id, java.net.URL location) throws RemoteException;
/**
 * This allows an agent to be sent from one MCD to another
 * @return boolean
 * @param id mct.users.MCIdentifier
 * @param flags java.util.BitSet
 * @param byteCode byte[]
 * @param properties java.util.Properties
 * @param url java.net.URL
 */
public boolean send(mct.users.MCIdentifier id, BitSet flags, byte[] byteCode, java.util.Properties properties, java.net.URL url) throws RemoteException;
/**
 * This method transfers byte code for a class from one MCD to 
 * another. It is to be used by an RMI-based network class loader.
 * @return byte[]
 * @param className java.lang.String
 * @param authority java.lang.String
 */
public byte[] transfer(String className, String authority) throws RemoteException;
}