package mct.admin;


/**
 * @(#)MobileCodeStubImplementation.java     June 2, 1997, Gatot Susilo
 */
/**************************************************************************
 *                    COPYRIGHT of MOBILE CODE TOOLKIT                    *
 *                                                                        *
 * This program is a free software and follows terms and conditions as    *
 * described on the GNU General Public License                            *
 * (see http://www.sce.carleton.ca/netmanage/gatot/gpl.html).             *
 * This software is freely distributed; however we recommend that         *
 * everybody should download a free copy directly from our site           *
 * http://www.sce.carleton.ca/netmanage/gatot.                            *
 * Therefore, we can keep a track who has got a copy and what for what    *
 * the purpose is. This will allow us to notify you when there are changes* 
 * or bugs fixed on the next release.                                     *                                   
 *                                                                        *
 * This program is a part of work in the Perpetuum Mobile Procura project.*
 * URL: http://www.sce.carleton.ca/netmanage/perpetuum.shtml.             *
 *                                                                        * 
 * Copyright 1997, Gatot Susilo                                           *
 * Department of Systems and Computer Engineering,                        *
 * Carleton University                                                    *
 *                                                                        *
 * Author: Gatot Susilo (susilo@sce.carleton.ca)                          *  
 * Date: October 5, 1997                                                  *
 * Contact Person:                                                        *
 *  Andrzej Bieszczad, Associate Professor, Systems & Computer Engineering*
 *  1125 Colonel By Drive, Carleton University, Ottawa, Canada K1S 5B6    *
 *  Email: andrzej@sce.carleton.ca    Tel:(613)520-5734  Fax:(613)520-5727*
 *  URL: http://www.sce.carleton.ca/faculty/bieszczad.html                *
 **************************************************************************
 *                                NO WARRANTY                             *
 *                                                                        *
 * BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY   *
 * FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN*
 * OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES *
 * PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER       *
 * EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED       *
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE*
 * ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH   *
 * YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL    *
 * NECESSARY SERVICING, REPAIR OR CORRECTION.                             *
 *                                                                        *    
 * IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING  *
 * WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR    *
 * REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR      *
 * DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL   *
 * DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM         *
 * (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED      *
 * INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF *
 * THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER OR*
 * OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 **************************************************************************/
import java.util.Hashtable;
import java.util.Enumeration;
import java.net.InetAddress;
import java.io.*;
import mct.users.*;
import mct.mediator.Message;
class MobileCodeStubImplementation implements MobileCodeStub {
	//**********
	//* Fields *
	//**********
	private MobileCodeObject mc;
	private MobileCodeManager mcm;
	private StorageManager storageManager;



MobileCodeStubImplementation(MobileCodeManager mcm, MobileCodeObject mc, StorageManager storageManager) {
	this.mcm = mcm;
	this.mc = mc;
	this.storageManager = storageManager;
}
public synchronized void addJAR(String name, byte bytes[]) {
	MobileCodeContainer mcc = storageManager.getContainer(name);
	if (mcc != null) {
		mcc.getJarTable().put(name, bytes);
		verifyMobileCodeContainer();
	}
}
public synchronized void destroy() {
	if (mc instanceof Callback)
		mcm.destroy(mc);
}
public synchronized MCTEventMulticaster getEventDispatcher() throws SecurityException {
	if (mc instanceof MCDInterface)
		return mcm.getEventDispatcher(mc);
	return null;
}
public synchronized java.net.URL[] getMigrationDestinations() {
	return mcm.getMigrationDestinations();
}
public synchronized MobileCodeContainer getMobileCodeContainer() {
	return storageManager.getContainer(mc.getID());
}
// Handle the MCDExtension if the mobile code implements MCDExtension
public synchronized Object getMobileCodeManager() throws SecurityException {
	if (mc instanceof MCDInterface)
		return mcm.getMobileCodeManager(mc);
	return null;
}
// Handle the Parameters if the mobile code implements Parameters
public synchronized Object getParameter(Object paramName) {
	if (mc instanceof Parameters)
		return mcm.getParameter(mc, paramName);
	return null;
}
public synchronized Enumeration getParameterNames() {
	if (mc instanceof Parameters)
		return mcm.getParameterNames(mc);
	return null;
}
public synchronized Enumeration getParameterValues() {
	if (mc instanceof Parameters)
		return mcm.getParameterValues(mc);
	return null;
}
public synchronized StorageManager getStorageManager() throws SecurityException {
	if (mc instanceof MCDInterface)
		return mcm.getStorageManager(mc);
	return null;
}
// Handle the VMCAccess if the mobile code implements VMCAccess
public synchronized MobileCodeObject getVirtualManagedComponent(String name, boolean className) {
	return mcm.getVirtualManagedComponent(mc, name, className);
}
public synchronized Enumeration getVirtualManagedComponentList() {
	return mcm.getVirtualManagedComponentList(mc);
}
public synchronized boolean hasMessages() {
	if (mc instanceof MessagingAccess)
		return mcm.hasMessages(mc);
	return false;
}
// Handle the Callback if the mobile code implements Callback
public synchronized boolean hasThread() {
	return mcm.getMobileCodeStatus(mc).hasThread();
}
public synchronized void init() {
	if (mc instanceof Callback)
		mcm.init(mc);
}
public synchronized void instantiate(MobileCodeContainer mcc) {
	if (mc instanceof MCDExtension)
		mcm.addElementToInstantiator(mcc);
}
// Handle the Callback if the mobile code implements 
// Callback and has a thread
public synchronized boolean isActive() {
	return mcm.isActive(mc);
}
public synchronized void migrate(String mobileCodeName, InetAddress ip, int port, boolean flag) {
	MobileCodeObject mobileCode = mcm.getMobileCodeHandle(mobileCodeName);
	if (mobileCode == null)
		return;
	if (mobileCode instanceof Migratable) {
		mcm.migrate(mobileCode, ip, port, flag);
	}
}
public synchronized void migrate(String mobileCodeName, boolean flag) {
	migrate(mobileCodeName, null, -1, flag);
}
public synchronized void migrate(MobileCodeObject mobileCode, InetAddress ip, int port, boolean flag) {
	if (mc instanceof Migratable) {
		mcm.migrate(mobileCode, ip, port, flag);
	}
}
/**
 * This method was created by a SmartGuide.
 * @param mobileCode mct.users.MobileCodeObject
 * @param ip java.net.InetAddress
 * @param destination mct.users.MCIdentifier
 */
public  synchronized void migrate(MobileCodeObject mobileCode, InetAddress ip, mct.users.MCIdentifier destination) {
	if (mc instanceof Migratable)
		mcm.migrate(mobileCode, ip, destination);
}
// Handle the Migration if the mobile code implements Migratable
public synchronized void migrate(MobileCodeObject mobileCode, boolean flag) {
	if (mc instanceof Migratable)
		migrate(mobileCode, null, -1, flag);
}
public synchronized Message peek() {
	if (mc instanceof MessagingAccess)
		return mcm.peek(mc);
	return null;
}
public synchronized void putParameter(Object paramName, Object paramValue) {
	if (mc instanceof Parameters)
		mcm.putParameter(mc, paramName, paramValue);
}
public synchronized Message receive() {
	if (mc instanceof MessagingAccess)
		return mcm.receive(mc, 0);
	return null;
}
/**
 * This method was created by a SmartGuide.
 * @return mct.mediator.Message
 * @param timer long
 */
public synchronized Message receive(long timer) {
	if (mc instanceof MessagingAccess)
		return mcm.receive(mc, timer);
	return null;
}
/**
 * This method was created by a SmartGuide.
 * @return mct.mediator.Message[]
 */
public synchronized Message[] receiveAll() {
	return receiveAll(0);
}
public synchronized Message[] receiveAll(long timer) {
	if (mc instanceof MessagingAccess)
		return mcm.receiveAll(mc, timer);
	return null;
}
public synchronized Object removeParameter(Object paramName) {
	if (mc instanceof Parameters)
		return mcm.removeParameter(mc, paramName);
	return null;
}
public synchronized void restore() {
	if (mc instanceof Callback)
		mcm.restore(mc);
}
public synchronized void resume() {
	if (mc instanceof Callback)
		mcm.resume(mc);
}
// Handle the MessagingAccess if the mobile code implements MessagingAccess
public synchronized boolean send(Message mesg) {
	if (mc instanceof MessagingAccess) {
		return mcm.send(mc, mesg);
	} else {
		return false;
	}
}
// Handle the MessagingAccess if the mobile code implements MessagingAccess
public synchronized boolean sendAsync(Message mesg) {
	if (mc instanceof MessagingAccess) {
		return mcm.sendAsync(mc, mesg);
	} else {
		return false;
	}
}
public synchronized void start() {
	if (mc instanceof Callback)
		mcm.start(mc);
}
public synchronized void stop() {
	if (mc instanceof Callback)
		mcm.stop(mc);
}
public void suspend() {
	if (mc instanceof Callback)
		mcm.suspend(mc);
}
public synchronized boolean verifyMobileCodeContainer() {
	MobileCodeContainer mcc = storageManager.getContainer(mc.getID());
	if (mcc != null)
		return mcm.verifyMobileCodeContainer(mcc);
	return false;
}
}