package mct.admin;


/**
 * This class was generated by a SmartGuide.
 * 
 */
import mct.users.MobileCodeObject;
public class RMIInstantiator extends Instantiator {



/**
 * RMIInstantiator constructor comment.
 * @param mobileCodeManager mct.admin.MobileCodeManager
 * @param storageManager mct.admin.StorageManager
 */
protected RMIInstantiator(MobileCodeManager mobileCodeManager, StorageManager storageManager) {
	super(mobileCodeManager, storageManager);
}
/**
   * Add a mobile code that is going to be instantiated by the daemon.
   * The mobile code must be stored/encapsulated in the MobileCodeContainer.
   * @see   mct.admin.MobileCodeContainer
   */
public synchronized void addElement(MobileCodeObject mcc) {
	queue.addElement(mcc);
	if (suspended) {
		resume();
	}
}
/**
   * The class runs as a thread. It instantiates a mobile code if it finds
   * a mobile code in its queue. If the queue is empty,
   * the thread is suspended, and it will be resumed when a mobile code is
   * added in the queue by using method addElement(MobileCodeContainer).<p>
   *
   * Note: transporting the mobile code to next default destination has not
   * been added if the mobile code does not pass the verifier's secuirity checks.
   * Instead the mobile code is just discarded.
   */
public void run() {
	while (true) {
		try {
			if (queue.isEmpty()) {
				suspended = true;
				suspend();
				suspended = false;
			}
			MobileCodeObject mco = (MobileCodeObject) queue.firstElement();
			queue.removeElementAt(0); // Remove first element
			mobileCodeManager.start(mco);
		} catch (Throwable e) {
			mct.Console.error(this, "Instantiator : exception occurs..");
			e.printStackTrace();
		}
	}
}
}