package mct.admin;


/**
 * This class was generated by a SmartGuide.
 * 
 */
import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;
import java.util.Properties;
import java.net.InetAddress;
import java.net.URL;
import java.lang.SecurityException;
import java.security.PublicKey;
import java.io.*;
import java.security.IdentityScope;
import java.security.PublicKey;
import java.rmi.*;
import mct.security.MobileCodeVerifier;
import mct.users.*;
import mct.mediator.Message;
import mct.security.MCDSecurityManager;
import mct.net.Ctp;
import mct.net.CtpException;
import mct.mediator.CommunicationFacilitatorInterface;
import mct.mediator.MobileCodeRecord;
import java.net.MalformedURLException;
public class RMIMobileCodeManager extends MobileCodeManager {
	private final static String UNRESOLVED_MIGRATION_DESTINATION = "";
	private String defaultMigrationTarget = "localhost";
	private String defaultMigrationName = "mct.admin.RemoteMigrationFacilitator";
	private Hashtable classLoaders = null;
	private URL migrationFacilitator = null;
	private MigrationInterface migrationService = null;
	private Hashtable migrationFacilitatorDestinations = null;



/**
 * RMIMobileCodeManager constructor comment.
 * @param storageManager mct.admin.StorageManager
 * @param byPassVerifier boolean
 */
public RMIMobileCodeManager(StorageManager storageManager, boolean byPassVerifier) {
	super(storageManager, byPassVerifier);
	classLoaders = new Hashtable();
	instantiator = new RMIInstantiator(this, storageManager);
	migrationFacilitatorDestinations = new Hashtable();
}
/**
 * This method was created by a SmartGuide.
 * @return mct.admin.MCTNetworkClassLoader
 * @param authority java.lang.String
 */
public MCTNetworkClassLoader getClassLoader(String authority) {
	return (MCTNetworkClassLoader) classLoaders.get(authority);
}
/**
 * This method was created by a SmartGuide.
 * @return mct.admin.MigrationInterface
 * @param destination java.lang.String
 */
public MigrationInterface getMigrationDestination(String destination) throws RemoteException, NotBoundException, MalformedURLException {
	Object mfd = migrationFacilitatorDestinations.get(destination);
	if (mfd instanceof MigrationInterface)
		return (MigrationInterface)mfd;
	else {
		mfd = Naming.lookup(destination);
		migrationFacilitatorDestinations.put(destination, mfd);
		return (MigrationInterface)mfd;
	}
}
/**
 * This method creates a lookup name for use in finding an entry in an
 * RMI repository.
 * @return java.lang.String
 * @param hostName java.lang.String
 * @param destination java.lang.String
 */
public static String getMigrationDestinationName(String hostName, String destination ) {
	return "//"+hostName+"/"+destination;
}
/**
 * This method returns an array of URLs which can be used as
 * migration destinations. The exception for MalformedURL is
 * ignored; the user just won't see the destination. Actually,
 * this should never happen.
 *
 * @return java.net.URL []
 */
public synchronized URL[] getMigrationDestinations() {
	Enumeration destinations = migrationFacilitatorDestinations.keys();
	if (destinations != null) {
		int i = -1;
		URL[] urlArray = new URL[migrationFacilitatorDestinations.size()];
		while (destinations.hasMoreElements()) {
			try {
				urlArray[++i] = new URL("file:"+destinations.nextElement());
			} catch (java.net.MalformedURLException ex) {	
				// Do nothing, we just won't see that destination
			}	
		}
		return urlArray;	
	}	
	return null;
}
/**
   * It instantiates the mobile code whose name is specified in the parameter.
   * It seeks the mobile code in the storage manager. If it founds
   * the mobile code in the storage manager, it uses MctClassLoader to instantiate
   * the mobile code. Otherwise, the mobile code is assumed from local system and instantiated
   * by using Class.forName(name).newInstance(). The class' constructor of mobile code must not
   * have parameter(s) because it is instantiated by using Class.newInstance().
   * If the mobile code is not found in the local system, the instantiation is cancelled.<p>
   *
   * As soon as the mobile code is instantiated and the MobileCodeDaemon (MCD) has
   * Facilitator installed (i.e., facilitator!=null), the mobile code will be registered
   * on Facilitator (local database) and on Mediator (central database).<p>
   * 
   * The latter is usefull for the initial mobile code that must be instantiated
   * as soon as the daemon is started.<p>
   *
   * It should be noted that every mobile code must implement interface MobileCode
   * and every virtual managed component must implement interface VMCMobileCode which
   * is subclass of interface MobileCode.
   *
   * @param name the absolute name of the mobile code. The name includes
   *	an identity as well as the class name. The @ symbol is used to delimit
   * the mobile code identifier and the 
   * @see mct.users.MobileCode
   * @see mct.users.VMCMobileCode
   * @see mct.mediator.Facilitator
   * @see mct.mediator.Mediator
   */
private boolean instantiateUsingClassLoader(String name, Properties properties) {
	MobileCodeContainer mcc = null;
	boolean persistent = false;
	MobileCodeObject mobileCode = null;
	String className = null;

	// Handle mobile code sent from network and stored in the StorageManager
	if ((mcc = storageManager.getContainer(name)) != null) {
		//System.out.println ("Instiate class in the storageManager");
		try {
			className = MCIdentifier.getClassFromIdentifier(name);
			MctClassLoader mcl = new MctClassLoader(storageManager, name);
			Object obj = null;
			// The mobile code does not have persistent state
			if (!mcc.hasPersistentState()) {
				Class c = mcl.loadClass(className, true);
				if (c == null)
					return false;
				obj = c.newInstance();
				// The mobile code has persistent state
			} else {
				persistent = true;
				ReadObjectStream ois = new ReadObjectStream(mcl, new ByteArrayInputStream(mcc.getPersistentState()));
				obj = ois.readObject();
			}

			// Just hack the storage of byte codes for now
			if ((obj != null) && (obj instanceof MobileCode)) {
				String authority = MCIdentifier.getClassFromIdentifier(name);
				MCTNetworkClassLoader mncl = obtainClassLoader(authority);
				if (mncl != null)
					mncl.setByteCodesForClass(className, mcl.loadClassData(className));
				mobileCode = (MobileCodeObject) obj;
			} else {
				obj = null;
				mct.Console.warning(this, "The mobile code does not implement MobileCode");
				return false;
			}
			// TBD 1 : If registerMobileCode returns false, there
			//	   should be garbage collection to remove the mobileCode
			return registerMobileCode(name, mobileCode, properties);
		} catch (ClassNotFoundException e) {
			mct.Console.warning(this, "Class not found: " + e);
		} catch (InstantiationException e) {
			mct.Console.warning(this, "Fail to instantiate class " + name);
		} catch (IllegalAccessException e) {
			mct.Console.warning(this, "I have no access to your class " + name);
		} catch (Throwable e) {
			mct.Console.warning(this, "Exception occurs");
			e.printStackTrace();
		}
	}
	return false;
}
/**
   * Call method onMigrate() for mobile code implementing Migratable interface to
   * let the mobile code know that it is about to be migrated. At this point,
   * the mobile code may refuse to migrate or allow to migrate with or without
   * persistent states. If the mobile code allows to migrate, it is migrated
   * to the next destination as sprecified in the parameters.<p>
   *
   * It should be noted that the migration with persistent state is done
   * by using serialization. Therefore all non-transient objects must
   * implement java.io.Serializable.
   *
   * @param name the instance of mobile code that will be migrated
   * @param ip the ip address of destination
   * @param port the port of destination
   * @param flag true if migration via TCP; false if migration via UDP
   */
public void migrate(MobileCodeObject name, InetAddress ip, int port, boolean flag) {
	String hostName;
	String migrationTarget;
	synchronized (name) {
		InetAddress destIp = ip;
		int destPort = port;
		if (ip == null) {
			if (flag == true) {
				destIp = ipTCP;
				destPort = portTCP;
			} else {
				destIp = ipUDP;
				destPort = portUDP;
			}
			hostName = defaultMigrationTarget;
			migrationTarget = defaultMigrationName;
		} else {
			hostName = ip.getHostName();
			migrationTarget = "[PUBLIC]@mct.admin.RemoteMigrationFacilitator";
		};
		MobileCodeStatus mcs = getMobileCodeStatus(name);
		if (mcs != null)
			synchronized (mcs) {
			if (name instanceof Migratable) {
				MigrationInterface migrator = null;
				String o = getMigrationDestinationName(hostName, migrationTarget);
				try {
					migrator = getMigrationDestination(o);
				} catch (Exception e) {
					migrationFacilitatorDestinations.put(o, UNRESOLVED_MIGRATION_DESTINATION);
					mct.Console.warning(null, name.getID() + " cannot migrate to " + o + " using RMI " + e);
					super.migrate(name, ip, port, flag);
					return;
				}


				// Only allow migration if we're not talking or doing something else
				// It is not possible to migrate while migrating, for example
				if (mcs.isRunning()) {
					ByteArrayOutputStream baos = null;
					boolean migrationFlag = false;
					mcs.beMigrating();
					MobileCodeContainer mcc = storageManager.getContainer(super.getID(name));
					synchronized (mcc) {
						migrationFlag = mcc.getMigrationFlag();
						mcc.setMigrationFlag();
						try {
							int retValue = ((Migratable) name).onMigrate();
							if (retValue == Migratable.DONT_MIGRATE) {
								return;
							} else
								if (retValue == Migratable.SERIALIZE) {
									baos = new ByteArrayOutputStream();
									ObjectOutputStream oos = new ObjectOutputStream(baos);
									oos.writeObject(name);
								}
						} catch (IOException ex) {
							if (!migrationFlag)
								mcc.clearMigrationFlag();
							mcs.beRunning();
							((Migratable) name).onFailMigrate(destIp, destPort, flag);
							return;
						}
						try {
							name.nextEvent();
							eventDispatcher.migrated(new MigratableEvent(name, MigratableEvent.MIGRATED));
							if (migrator.send(name.getIdentifier(), mcc.getFlags(), baos.toByteArray(), mcc.getParameters(), migrationFacilitator)) {
								mcs.beMigrated();
								destroy(name);
								return;
							} else
								throw new RemoteException("refused by remote migration facility");
						} catch (RemoteException ex) {
							mct.Console.warning(null, name.getID() + " had transport problem:\n" + ex);
							if (!migrationFlag)
								mcc.clearMigrationFlag();
							mcs.beRunning();
							((Migratable) name).onFailMigrate(destIp, destPort, flag);
							eventDispatcher.netletInitialized(new CallbackEvent(name, CallbackEvent.INITIALIZED));
						} catch (java.lang.ThreadDeath e) {
							// Have to rethrow this in order to ensure that threads are 
							// tidied up properly and zombie threads don't appear.
							throw e;
						}
					}
				}
			}
		}
		((Migratable) name).onFailMigrate(destIp, destPort, flag);
	}
}
/**
   * Call method onMigrate() for mobile code implementing Migratable interface to
   * let the mobile code know that it is about to be migrated. At this point,
   * the mobile code may refuse to migrate or allow to migrate with or without
   * persistent states. If the mobile code allows to migrate, it is migrated
   * to the next destination as sprecified in the parameters.<p>
   *
   * It should be noted that the migration with persistent state is done
   * by using serialization. Therefore all non-transient objects must
   * implement java.io.Serializable.
   *
   * @param name the instance of mobile code that will be migrated
   * @param ip the ip address of destination
   * @param destination MCIdentifier
   */
public void migrate(MobileCodeObject name, InetAddress ip, MCIdentifier destination) {
	String hostName;
	String migrationTarget;
	synchronized (name) {
		InetAddress destIp = ip;
		int destPort = -1;
		// Set up the migration destination host
		if (ip == null) {
			if (TCPflag == true) {
				destIp = ipTCP;
				destPort = portTCP;
			} else {
				destIp = ipUDP;
				destPort = portUDP;
			}
			hostName = defaultMigrationTarget;
		} else {
			hostName = ip.getHostName();
		};
		// Set up the destination
		if (destination == null)
			migrationTarget = defaultMigrationName;
		else
			migrationTarget = destination.getID();
		MobileCodeStatus mcs = getMobileCodeStatus(name);
		if (mcs != null)
			synchronized (mcs) {
			if (name instanceof Migratable) {
				MigrationInterface migrator = null;
				String o = getMigrationDestinationName(hostName, migrationTarget);
				try {
					migrator = getMigrationDestination(o);
				} catch (Exception e) {
					migrationFacilitatorDestinations.put(o, UNRESOLVED_MIGRATION_DESTINATION);
					mct.Console.warning(null, name.getID() + " cannot migrate to " + o + " using RMI " + e);
					super.migrate(name, ip, -1, TCPflag);
					return;
				}


				// Only allow migration if we're not talking or doing something else
				// It is not possible to migrate while migrating, for example
				if (mcs.isRunning()) {
					ByteArrayOutputStream baos = null;
					boolean migrationFlag = false;
					mcs.beMigrating();
					MobileCodeContainer mcc = storageManager.getContainer(super.getID(name));
					synchronized (mcc) {
						migrationFlag = mcc.getMigrationFlag();
						mcc.setMigrationFlag();
						try {
							int retValue = ((Migratable) name).onMigrate();
							if (retValue == Migratable.DONT_MIGRATE) {
								return;
							} else
								if (retValue == Migratable.SERIALIZE) {
									baos = new ByteArrayOutputStream();
									ObjectOutputStream oos = new ObjectOutputStream(baos);
									oos.writeObject(name);
								}
						} catch (IOException ex) {
							if (!migrationFlag)
								mcc.clearMigrationFlag();
							mcs.beRunning();
							((Migratable) name).onFailMigrate(destIp, destPort, TCPflag);
							return;
						}
						try {
							name.nextEvent();
							eventDispatcher.migrated(new MigratableEvent(name, MigratableEvent.MIGRATED));
							if (migrator.send(name.getIdentifier(), mcc.getFlags(), baos.toByteArray(), mcc.getParameters(), migrationFacilitator)) {
								mcs.beMigrated();
								destroy(name);
								return;
							} else
								throw new RemoteException("refused by remote migration facility");
						} catch (RemoteException ex) {
							mct.Console.warning(null, name.getID() + " had transport problem:\n" + ex);
							if (!migrationFlag)
								mcc.clearMigrationFlag();
							mcs.beRunning();
							((Migratable) name).onFailMigrate(destIp, destPort, TCPflag);
							eventDispatcher.netletInitialized(new CallbackEvent(name, CallbackEvent.INITIALIZED));
						} catch (java.lang.ThreadDeath e) {
							// Have to rethrow this in order to ensure that threads are 
							// tidied up properly and zombie threads don't appear.
							throw e;
						}
					}
				}
			}
		}
		((Migratable) name).onFailMigrate(destIp, destPort, TCPflag);
	}
}
/**
 * This method was created by a SmartGuide.
 * @return mct.admin.MCTNetworkClassLoader
 * @param authority java.lang.String
 */
public MCTNetworkClassLoader obtainClassLoader(String authority) {
	Object obj = classLoaders.get(authority);
	if (obj instanceof MCTNetworkClassLoader)
		return (MCTNetworkClassLoader) obj;
	else {
		MCTNetworkClassLoader cl = new MCTNetworkClassLoader(authority);
		classLoaders.put(authority, cl);
		return cl;
	}
}
/*
   * @param properties Properties the properties to be given to the mobile code 
   * @param mobileCodeObject MobileCode the mobile code being registered
   * @param name String the name of the mobile code
   */
protected synchronized boolean registerMobileCode(String name, MobileCodeObject mobileCode, Properties properties) {
	MobileCodeStub stub = null;
	try {
		// Create an identifier for the mobile code based upon name
		// Really this should already have been done.
		mobileCode.setIdentifier(new MCIdentifier(name));

		// Ensure that the mobile code has a stub associated with it.
		// The stub is absolutely essential to the well being of the mobile code object
		mobileCode.setStub(new MobileCodeStubImplementation(this, mobileCode, storageManager));

		// Obtain the mobile code container and ensure that the event number is
		// correctly initialized. This ensures that we can update mobile code
		// directories. THIS IS CRUCIAL TO THE CORRECT OPERATION OF THE DIRECTORY
		MobileCodeContainer mcc = storageManager.getContainer(mobileCode.getID());
		if (mcc != null && mcc.hasMigrated())
			mobileCode.nextEvent();
		else
			mobileCode.resetEventNumber();

		// The stub has been initialized and so we send the initialized event
		// to all interested parties.
		eventDispatcher.addMobileCode(new MCEvent(mobileCode, MCEvent.INSTALLED));

		// If we have migrated, we use onRestore. Otherwise, we use onInit.
		boolean callInit = true;
		if (mobileCode instanceof Migratable) {
			if (mcc != null && mcc.hasMigrated()) {
				callInit = false;
				if (!((Migratable) mobileCode).onRestore()) {
					mct.Console.warning(this, "Restoration failed for  " + mobileCode);
					return false; // Abort registration due to restoration errors
				}
			}
		}
		if (callInit) {
			if (!mobileCode.onInit(properties)) {
				mct.Console.warning(this, "Instantiation failed for  " + mobileCode);
				return false; // Abort registration due to initialization errors
			}
		}
		mobileCode.nextEvent();
		eventDispatcher.netletInitialized(new CallbackEvent(mobileCode, CallbackEvent.INITIALIZED));

		// At this point, the code is installed, and 
		// other netlets can get this mobileCode's handle.
		// Mark this event (done in start(mobileCode)).

		mobileCodeInstances.put(name, new MobileCodeStatus(mobileCode));
		instantiator.addElement(mobileCode);

		// We've now ensured that the mobile code is okay to run.
		// Now set up its messaging access (mailbox etc)

		if (facilitator instanceof mct.mediator.CommunicationFacilitatorInterface)
			facilitator.startMbx(mobileCode.getID());
		return true;
	} catch (Throwable e) {
		mct.Console.warning(this, "Exception occurs during registration: " + e);
		e.printStackTrace();
	}
	return false;
}
/**
 * This method sets the default RMI migration parameters
 * for the manager. The last migration pair is considered to
 * be the default.
 *
 * @param host java.lang.String
 * @param name java.lang.String
 */
public void setDefaultRMIMigrationParameters(String host, String name) {
	// Actual host where the migration facilitator should be found
	defaultMigrationTarget = host;
	// Ensure that we end up with an authority specified
	defaultMigrationName = (new MCIdentifier(name)).getID();
	// Add the migration parameters into the hashtable of MigrationInterfaces
	// We do not attempt to resolve the destination to an actual interface until
	// we try to use it.
	migrationFacilitatorDestinations.put(getMigrationDestinationName(host, defaultMigrationName), UNRESOLVED_MIGRATION_DESTINATION);
}
/**
 * This method was created by a SmartGuide.
 * @return java.net.URL
 * @param mc mct.users.MobileCodeObject
 */
public void setMigrationFacilitator(MobileCodeObject mc) {
	if (migrationService == null) {
		// Save the URL of the migration facilitator
		// which isn't particularly useful.
		try {
			migrationFacilitator = new java.net.URL("file://localhost/" + mc.getID());
		} catch (IOException ex) {
			migrationFacilitator = null;
		}
		// Just save this object in order to avoid garbage collection
		migrationService = (MigrationInterface) mc;
	} else {
		mct.Console.warning(this, "can only set Migration Facilitator once");
	}
}
}