package mct.admin;

/**
 * This type was created by Tony White.
 * It is an implementation of a Semaphore
 */
 import java.util.Vector;
 
public class Semaphore {
	private int count = 0;
	private Vector threads;
/**
 * Semaphore constructor comment.
 */
public Semaphore() {
	super();
	threads = new Vector();
}
/**
 * This method was created by Tony White.
 * @param count int 
 */
public Semaphore(int count) {
	super();
	this.count = count;
	threads = new Vector();
}
/**
 * This method was created by Tony White.
 * This method allows for notification of threads which
 * are waiting on this semaphore. 
 */
public final void snotify() {
	synchronized (threads) {
		if (count == 0) {
			Thread thread = (Thread) threads.firstElement();
			threads.removeElementAt(0);
			thread.resume();
		}
		else
			count++;
	}
}
/**
 * This method was created by Tony White.
 * This method allows a thread (the currently active one)
 * to wait for the semaphore if outstanding notifications
 * don't already exist.
 */
public final void swait() {
	synchronized (threads) {
		if (count == 0) {
			Thread thread = Thread.currentThread();
			threads.addElement(thread);
			thread.suspend();
		} else
			count--;
	}
}
}