package mct.blackboard;


/**
 *@(#)BlackBoard.java    
 */

import java.io.*;
import java.net.*;

/**
 * The interface defines the services provided by a blackboard.
 * It must be implemented by any mobileCode that provides this service
 */

public interface BlackBoard {
	public final static String REGISTER = "Register";
	public final static String POST = "Post";
	public final static String ENQUIRE = "Enquire";
	public final static String ENQUIRE_REPLY = "EnquireReply";
	public final static String NOTIFY = "Notify";



public abstract boolean deRegister(String mcName, Object key);
public abstract Object enquire(String mcName, Object key);
public boolean isAvailable();
public abstract boolean post(Object key, Object message);
public abstract boolean register(String mcName, Object key);
}