package mct.blackboard;


/**
 *@(#)NotifyMessage.java  
 *
 * The message is sent by a blackboard to a mobileCode that has
 * previously registered as a listener, whenever a posting
 * is made for the registered key.  The current posting
 * is sent with the notification to the mobileCode
 */

public class NotifyMessage extends BlackBoardMessage {



/**
   * Constructs the Notification Message
   */
public NotifyMessage(String blackBoard, String mcID, Object key, Object message) {
	super(blackBoard, mcID, key);
	super.addMessage("contents", message);
}
/**
   * Returns the object that was just posted on the blackboard
   */
public Object getContents() {
	Object value[];
	if ((value = super.getMessages("contents")) != null) {
		return value[0];
	}
	return null;
}
}