package mct.clients;


import java.net.URL;
import java.net.URLConnection;
import java.util.Hashtable;
import java.util.Properties;
import java.util.zip.*;
import java.util.BitSet;
import java.rmi.*;
import java.rmi.server.UnicastRemoteObject;
import java.awt.*;
import java.io.*;
import sun.tools.java.ClassPath;
import sun.tools.java.ClassFile;
import mct.users.*;
import mct.admin.*;
/**
 * @(#) RemoteMigrationFacilitator.java	1.0 September-23-1998	Tony White
 * 
 */
public class InjectMobileCodeFacilitator extends SuperVirtualManagedComponent implements mct.admin.MigrationInterface {
	public boolean available = false;
	private ClassPath cPath = null;
	static private String JAR_FILE_EXTENSION = ".jar";
	static private String CLASS_FILE_EXTENSION = ".class";



/**
 * RemoteMigrationFacilitator constructor comment.
 * @param instantiator Instantiator
 */
public InjectMobileCodeFacilitator() throws RemoteException {
	super();
	UnicastRemoteObject.exportObject(this);
}
/**
 * RemoteMigrationFacilitator constructor comment.
 * @param id java.lang.String
 */
public InjectMobileCodeFacilitator(String id) throws RemoteException {
	super(id);
	UnicastRemoteObject.exportObject(this);
}
/**
 * This method was created in VisualAge.
 */
public void finalize() {
	available = false;
	try {
		Naming.unbind(getID());
	} catch (Exception e) {
		mct.Console.error(this, "cannot unbind MigrationFacilitor in RMI registry\nReason: " + e);
	}
}
/**
 * Bind the object in the RMI registry locally. Maybe we'll extend 
 * this to add the entry in several registries for fault tolerance.
 * @param properties java.util.Properties
 * @return boolean
 */
public boolean onInit(java.util.Properties properties) {
	try {
		Naming.rebind(getID(), this);
		available = true;
	} catch (Exception e) {
		mct.Console.error(this, "cannot rebind MigrationFacilitor in RMI registry" + e);
		return false;
	}
	return true;
}
/**
 * send method comment.
 */
public boolean send(MCIdentifier id, byte[] state, java.net.URL codebase) throws RemoteException {
	return send(id, null, null, null, codebase);
}
/**
 * send method comment.
 */
public boolean send(MCIdentifier id, java.net.URL codebase) throws RemoteException {
	return send(id, null, null, null, codebase);
}
/**
 * send method comment.
 */
public boolean send(MCIdentifier id, BitSet flags, byte[] state, Properties properties, java.net.URL codebase) throws RemoteException {
	throw new RemoteException("Cannot send code using this class");
}
/**
 * transfer method comment.
 */
public byte[] transfer(String className, String authority) throws RemoteException {
	try {
		if (cPath == null) {
			mct.Console.info(null, getID() + " transferring " + className + " " + authority);
			// Get the classpath for this application
			Properties properties = System.getProperties();
			String classPath = (String) properties.get("java.class.path");
			// Create a class path object (for easy search for class)
			cPath = new ClassPath(classPath);
		}
		// Ensure that the user has specified a class (strip off instance)
		String sClass = MCIdentifier.getClassFromIdentifier(className);
		sClass = sClass.replace('.', File.separator.charAt(0));

		// Determine if the file can be found
		ClassFile file;
		try {
			file = cPath.getFile(sClass + JAR_FILE_EXTENSION);
			java.io.InputStream is = file.getInputStream();
			byte[] byteCode = new byte[is.available()];
			is.read(byteCode, 0, is.available());
			is.close();
			return byteCode;
		} catch (Exception ioex) {
			file = cPath.getFile(sClass + CLASS_FILE_EXTENSION);
			if (file == null)
				throw new java.io.FileNotFoundException(sClass + ".jar or .class");
			mct.Console.warning(this, "creating jar for " + className);
			java.io.InputStream is = file.getInputStream();
			byte[] byteCode = new byte[is.available()];
			is.read(byteCode, 0, is.available());
			is.close();
			ByteArrayOutputStream baos = new ByteArrayOutputStream();
			ZipOutputStream zos = new ZipOutputStream(baos);
			ZipEntry entry = new ZipEntry(className + CLASS_FILE_EXTENSION);
			entry.setMethod(ZipEntry.DEFLATED);
			zos.putNextEntry(entry);
			zos.write(byteCode, 0, byteCode.length);
			zos.closeEntry();
			zos.close();
			return baos.toByteArray();
		}
	} catch (Throwable e) {
		if (e instanceof RemoteException)
			throw (RemoteException)e;
		else
			throw new RemoteException(e.toString());
	}
}
}