package mct.examples.Installer;


/**
 *@(#)Installer.java    Gatot Susilo  September 04, 1997
 */
/**************************************************************************
 *                    COPYRIGHT of MOBILE CODE TOOLKIT                    *
 *                                                                        *
 * This program is a free software and follows terms and conditions as    *
 * described on the GNU General Public License                            *
 * (see http://www.sce.carleton.ca/netmanage/gatot/gpl.html).             *
 * This software is freely distributed; however we recommend that         *
 * everybody should download a free copy directly from our site           *
 * http://www.sce.carleton.ca/netmanage/gatot.                            *
 * Therefore, we can keep a track who has got a copy and what for what    *
 * the purpose is. This will allow us to notify you when there are changes* 
 * or bugs fixed on the next release.                                     *                                   
 *                                                                        *
 * This program is a part of work in the Perpetuum Mobile Procura project.*
 * URL: http://www.sce.carleton.ca/netmanage/perpetuum.shtml.             *
 *                                                                        * 
 * Copyright 1997, Gatot Susilo                                           *
 * Department of Systems and Computer Engineering,                        *
 * Carleton University                                                    *
 *                                                                        *
 * Author: Gatot Susilo (susilo@sce.carleton.ca)                          *  
 * Date: October 5, 1997                                                  *
 * Contact Person:                                                        *
 *  Andrzej Bieszczad, Associate Professor, Systems & Computer Engineering*
 *  1125 Colonel By Drive, Carleton University, Ottawa, Canada K1S 5B6    *
 *  Email: andrzej@sce.carleton.ca    Tel:(613)520-5734  Fax:(613)520-5727*
 *  URL: http://www.sce.carleton.ca/faculty/bieszczad.html                *
 **************************************************************************
 *                                NO WARRANTY                             *
 *                                                                        *
 * BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY   *
 * FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN*
 * OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES *
 * PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER       *
 * EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED       *
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE*
 * ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH   *
 * YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL    *
 * NECESSARY SERVICING, REPAIR OR CORRECTION.                             *
 *                                                                        *    
 * IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING  *
 * WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR    *
 * REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR      *
 * DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL   *
 * DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM         *
 * (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED      *
 * INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF *
 * THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER OR*
 * OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 **************************************************************************/
import mct.users.Extlet;
import mct.users.MCDExtension;
import mct.admin.MobileCodeContainer;
import java.io.*;
import java.util.Enumeration;

/**
 * This class demonstrates the mobile code implementing 
 * MCDExtension may install another mobile code on the daemon.
 * So I pretend to pull another mobile code and instantiate it.
 * Since I just read from local file system, make sure you
 * disable MCDSecurityManager before you run this example.
 * The daemon must be started from the directory where this example
 * exists. Use the <b>daemon.prop</b> as the properties file of the
 * daemon.
 */
public class Installer extends Extlet {



public void onDestroy() {
	System.out.println("Installer: onDestroy() is called");
}
public boolean onInit() {
	System.out.println("Installer: onInit() is called");
	putParameter("Hello", "Hello.jar");
	return true;
}
public void onStart() {
	System.out.println("Installer: onStart() is called");
	for (Enumeration e = getParameterNames(); e.hasMoreElements();) {
		String className = (String) e.nextElement();
		MobileCodeContainer mcc = new MobileCodeContainer(className);
		try {
			System.out.println("Read file " + className);
			String fileName = (String) getParameter(className);
			if (fileName != null) {
				FileInputStream fis = new FileInputStream(fileName);
				DataInputStream dis = new DataInputStream(fis);
				byte bytes[] = new byte[fis.available()];
				dis.readFully(bytes);
				System.out.println("Put it in the MobileCodeContainer");
				mcc.getJarTable().put(className, bytes);
				System.out.println("Install it now..");
				instantiate(mcc);
				System.out.println("Instantiation is completed");
			}
		} catch (Throwable ex) {
			System.out.println("Something wrong in reading the file");
			ex.printStackTrace();
		}
	}
}
public void onStop() {
	System.out.println("Installer: onStop() is called");
}
}