package mct.examples.Netcomm;


/**
 *@(#)NetComm03.java      Gatot Susilo    August 28, 1997
 */
/**************************************************************************
 *                    COPYRIGHT of MOBILE CODE TOOLKIT                    *
 *                                                                        *
 * This program is a free software and follows terms and conditions as    *
 * described on the GNU General Public License                            *
 * (see http://www.sce.carleton.ca/netmanage/gatot/gpl.html).             *
 * This software is freely distributed; however we recommend that         *
 * everybody should download a free copy directly from our site           *
 * http://www.sce.carleton.ca/netmanage/gatot.                            *
 * Therefore, we can keep a track who has got a copy and what for what    *
 * the purpose is. This will allow us to notify you when there are changes* 
 * or bugs fixed on the next release.                                     *                                   
 *                                                                        *
 * This program is a part of work in the Perpetuum Mobile Procura project.*
 * URL: http://www.sce.carleton.ca/netmanage/perpetuum.shtml.             *
 *                                                                        * 
 * Copyright 1997, Gatot Susilo                                           *
 * Department of Systems and Computer Engineering,                        *
 * Carleton University                                                    *
 *                                                                        *
 * Author: Gatot Susilo (susilo@sce.carleton.ca)                          *  
 * Date: October 5, 1997                                                  *
 * Contact Person:                                                        *
 *  Andrzej Bieszczad, Associate Professor, Systems & Computer Engineering*
 *  1125 Colonel By Drive, Carleton University, Ottawa, Canada K1S 5B6    *
 *  Email: andrzej@sce.carleton.ca    Tel:(613)520-5734  Fax:(613)520-5727*
 *  URL: http://www.sce.carleton.ca/faculty/bieszczad.html                *
 **************************************************************************
 *                                NO WARRANTY                             *
 *                                                                        *
 * BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY   *
 * FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN*
 * OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES *
 * PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER       *
 * EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED       *
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE*
 * ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH   *
 * YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL    *
 * NECESSARY SERVICING, REPAIR OR CORRECTION.                             *
 *                                                                        *    
 * IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING  *
 * WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR    *
 * REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR      *
 * DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL   *
 * DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM         *
 * (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED      *
 * INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF *
 * THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER OR*
 * OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 **************************************************************************/
import mct.users.Netlet;
import mct.users.MessagingAccess;
import mct.mediator.Message;
import java.io.*;
import java.util.*;

/**
 * This netlet demonstrates the communication between mobile code
 * implementing interface MessagingAccess.<p>
 * In this example, the netlet <b>NetComm03</b> wants to send a message
 * to everyone in the network (i.e., ALL). Before you run this example,
 * you have to run the mobile code daemon with Facilitator enabled and
 * another mobile code daemon with Mediator enabled. 
 * Inject the NetComm01 and NetComm02, and finally inject this netlet.
 */
public class NetComm extends Netlet implements MessagingAccess {



public boolean onInit() {
	System.out.println(getID()+": Hi.. I am initializing ");
	return true;
}
public void onMessage() {
	System.out.println(getID() + ": I got a new message... so retrieve it");
	Message mesg = receive();
	if (mesg != null) {
		System.out.println("From: " + mesg.getFrom());
		System.out.println("To: " + mesg.getTo());
		System.out.println("Content:");
		Enumeration enum = mesg.getTags();
		while (enum.hasMoreElements()) {
			String tag = (String) enum.nextElement();
			Object obj[] = mesg.getMessages(tag);
			System.out.println("\tTag: " + tag + " Length: " + obj.length + " Values: ");
			for (int i = 0; i < obj.length; i++) {
				System.out.println("\t\t" + i + ". " + obj[i]);
			}
		}
	}
}
public void onMessage1() {
	System.out.println(getID() + ": I got a new message... so retrieve it");
	Message mesg[] = receiveAll();
	if (mesg != null) {
		System.out.println("Receive : " + mesg.length);
		System.out.println("From: " + mesg[0].getFrom());
		System.out.println("To: " + mesg[0].getTo());
		System.out.println("Content:");
		Enumeration enum = mesg[0].getTags();
		while (enum.hasMoreElements()) {
			String tag = (String) enum.nextElement();
			Object obj[] = mesg[0].getMessages(tag);
			System.out.println("\tTag: " + tag + " Length: " + obj.length + " Values: ");
			for (int i = 0; i < obj.length; i++) {
				System.out.println("\t\t" + i + ". " + obj[i]);
			}
		}
	}
}
public void onStart() {
	// The subclasses do real stuff here
}
public void onStop() {
	System.out.println(getID()+": I am stopping");
}
public Message receive() {
	return getStub().receive();
}
/**
 * This method was created by a SmartGuide.
 * @return mct.mediator.Message
 * @param timer long
 */
public Message receive(long timer) {
	return getStub().receive(timer);
}
public Message[] receiveAll() {
	return getStub().receiveAll();
}
/**
 * This method was created by a SmartGuide.
 * @return mct.mediator.Message[]
 * @param timer long
 */
public Message[] receiveAll(long timer) {
	return getStub().receiveAll(timer);
}
public boolean send(Message mesg) {
	return getStub().send(mesg);
}
public boolean sendAsync(Message mesg) {
	return getStub().sendAsync(mesg);
}
}