package mct.examples.NetletTester;


/**
 * @(#)SimpleMO.java    05-Feb-1997 Gatot Susilo
 */
/**************************************************************************
 *                    COPYRIGHT of MOBILE CODE TOOLKIT                    *
 *                                                                        *
 * This program is a free software and follows terms and conditions as    *
 * described on the GNU General Public License                            *
 * (see http://www.sce.carleton.ca/netmanage/gatot/gpl.html).             *
 * This software is freely distributed; however we recommend that         *
 * everybody should download a free copy directly from our site           *
 * http://www.sce.carleton.ca/netmanage/gatot.                            *
 * Therefore, we can keep a track who has got a copy and what for what    *
 * the purpose is. This will allow us to notify you when there are changes* 
 * or bugs fixed on the next release.                                     *                                   
 *                                                                        *
 * This program is a part of work in the Perpetuum Mobile Procura project.*
 * URL: http://www.sce.carleton.ca/netmanage/perpetuum.shtml.             *
 *                                                                        * 
 * Copyright 1997, Gatot Susilo                                           *
 * Department of Systems and Computer Engineering,                        *
 * Carleton University                                                    *
 *                                                                        *
 * Author: Gatot Susilo (susilo@sce.carleton.ca)                          *  
 * Date: October 5, 1997                                                  *
 * Contact Person:                                                        *
 *  Andrzej Bieszczad, Associate Professor, Systems & Computer Engineering*
 *  1125 Colonel By Drive, Carleton University, Ottawa, Canada K1S 5B6    *
 *  Email: andrzej@sce.carleton.ca    Tel:(613)520-5734  Fax:(613)520-5727*
 *  URL: http://www.sce.carleton.ca/faculty/bieszczad.html                *
 **************************************************************************
 *                                NO WARRANTY                             *
 *                                                                        *
 * BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY   *
 * FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN*
 * OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES *
 * PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER       *
 * EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED       *
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE*
 * ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH   *
 * YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL    *
 * NECESSARY SERVICING, REPAIR OR CORRECTION.                             *
 *                                                                        *    
 * IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING  *
 * WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR    *
 * REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR      *
 * DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL   *
 * DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM         *
 * (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED      *
 * INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF *
 * THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER OR*
 * OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 **************************************************************************/
import java.util.*;
import mct.users.VirtualManagedComponent;
import mct.users.VMCException;

/**
 * This demonstrates how to implement a managed object
 * that may access to information on a specific network element.
 * This VMC will be accessed by <b>NetletTester</b>
 */
public class SimpleVMC extends VirtualManagedComponent {
	// Pretend this is my Database table
	private Hashtable table;

	// Define a read only object
	private String readOnlyObject = "Adapter";



public SimpleVMC() {
	super("OC-1234");
	System.out.println("SIMPLE VMC");
	table = new Hashtable();
	table.put("Adapter", "Ethernet");
	table.put("Brand", "3 Com");
	table.put("Speed", "100Mbps");
	table.put("Address", "40:20:FF:08");
	table.put("Link", "Up");
}
public void delete(Object name) {
}
/**
   * Get a parameter
   */
public Object get(Object name) throws VMCException {
	if (table.containsKey(name))
		return table.get(name);
	else
		throw new VMCException("Invalid object name");
	// return null;
}
public Object getBulk(Object name[]) throws VMCException {
	return null;
}
/**
   * Get next object with respect to object specified on
   * the parameter.
   */
public Object getNext(Object name) throws VMCException {
	Enumeration enum = table.keys();
	boolean found = false;
	while (enum.hasMoreElements()) {
		Object element = enum.nextElement();
		if (found)
			return element;
		if (element.equals(name))
			found = true;
	}
	throw new VMCException("Object is not found");
	// return null;
}
/**
   * Return all object names
   */
public Object getObjectList() {
	return table.keys();
}
/**
   * Check for permission of an object
   */
public boolean isReadOnly(Object name) {
	if (((String) name).equals(readOnlyObject))
		return true;
	return false;
}
/**
   * Set an object whose name and value are specified
   */
public void set(Object name, Object value) throws VMCException {
	if (table.containsKey(name)) {
		if (((String) name).equals(readOnlyObject))
			throw new VMCException("Fail to set, object is read only");
		else
			table.put(name, value);
	} else {
		throw new VMCException("Invalid object name");
	}
}
}