package mct.examples.messaging;


/**
 * @(#)PostNetlet.java	1.0 October-13-1997	Cheryl Schramm
 *
 * 	The Netlet repeatedly posts messages to the BlackBoard.
 *	Between transmissions, the netlet sleeps and migrates.
 *
 */

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;
import mct.users.*;
import mct.admin.*;
import mct.net.*;
import mct.mediator.*;
import mct.blackboard.*;
public class PostNetlet extends SuperNetlet implements Serializable {
	private int tries = 0;



public void onDestroy() {
}
public void onFailMigrate(InetAddress ip, int port, boolean isTCP) {
	tries++;
	System.err.println("PostNetlet::onFailMigrate " + ip + port + isTCP);
	try {
		Thread.sleep(1000);
	} catch (java.lang.InterruptedException ex) {
	};
	if (tries < 5)
		migrate(this, true);
}
public boolean onInit() {
	if (getParameter("blackboard") == null)
		putParameter("blackboard", "blackboard[PUBLIC]@mct.blackboard.MsgBlackBoard");
	if (getParameter("nhops") == null)
		putParameter("nhops", new Integer(0));
	return true;
}
public boolean onInit(java.util.Properties properties) {
	// Set variables defined as properties
	if (properties != null) {
		String bb = properties.getProperty("PostNetlet.blackboard", "blackboard[PUBLIC]@mct.blackboard.MsgBlackBoard");
		putParameter("blackboard", bb);
		putParameter("nhops", new Integer(0));
		return true;
	} else
		return onInit();
}
public void onStart() {
	tries = 0;
	Integer nhops = (Integer) getParameter("nhops");
	System.out.println(getID() + " : onStart " + nhops.intValue());
	PostMessage msg = new PostMessage(getID(), (String) getParameter("blackboard"), "nhops", nhops);
	System.out.println(getID() + " posting nhops = " + nhops.intValue());
	int stries = 0;
	while (!send(msg) && stries < 5) {
		stries++;
		mct.Console.application(null, getID() + " failed to post nhops = " + nhops.intValue());
		try {
			Thread.sleep(1000);
			System.out.println(getID()+" sleeping while sending...");
		} catch (InterruptedException ie) {
		}
	}
	nhops = new Integer(nhops.intValue() + 1);
	System.out.println(getID() + " MIGRATING " + nhops.intValue());
	putParameter("nhops", nhops);
	// Sleep in order to let another thread have a turn
	try {
		Thread.sleep(500);
	} catch (InterruptedException ex) {
	}
	migrate(this, true);
}
public void onStop() {
}
}