package mct.management;


/**
 * This interface allows a remote client to control mobile code within a
 * running mobile code daemon
 */
import java.rmi.RemoteException;
public interface ManagementInterface extends java.rmi.Remote {


/**
 * This method destroys the agent locally. The value true
 * is returned if successful, false otherwise.
 * @return boolean
 * @param id mct.users.MCIdentifier
 */
boolean destroy(mct.users.MCIdentifier id) throws RemoteException;
/**
 * This method allows a mobile code to be resumed locally. The
 * value true is returned if the mobile code could be resumed,
 * false otherwise.
 * @return boolean
 * @param id mct.users.MCIdentifier
 */
boolean resume(mct.users.MCIdentifier id) throws RemoteException;
/**
 * This method allows a mobile code to be started locally. The
 * value true is returned if the mobile code could be started,
 * false otherwise.
 * @return boolean
 * @param id mct.users.MCIdentifier
 */
boolean start(mct.users.MCIdentifier id) throws RemoteException;
/**
 * This method allows a mobile code to be stopped locally. The
 * value true is returned if the mobile code could be stopped,
 * false otherwise.
 * @return boolean
 * @param id mct.users.MCIdentifier
 */
boolean stop(mct.users.MCIdentifier id) throws RemoteException;
/**
 * This method allows a mobile code to be suspended locally. The
 * value true is returned if the mobile code could be suspended,
 * false otherwise.
 * @return boolean
 * @param id mct.users.MCIdentifier
 */
boolean suspend(mct.users.MCIdentifier id) throws RemoteException;
}