package mct.mediator;


/**
 *@(#)CommunicationFacilitatorInterface.java     Gatot Susilo  August 26, 1997
 */
/**************************************************************************
 *                    COPYRIGHT of MOBILE CODE TOOLKIT                    *
 *                                                                        *
 * This program is a free software and follows terms and conditions as    *
 * described on the GNU General Public License                            *
 * (see http://www.sce.carleton.ca/netmanage/gatot/gpl.html).             *
 * This software is freely distributed; however we recommend that         *
 * everybody should download a free copy directly from our site           *
 * http://www.sce.carleton.ca/netmanage/gatot.                            *
 * Therefore, we can keep a track who has got a copy and what for what    *
 * the purpose is. This will allow us to notify you when there are changes* 
 * or bugs fixed on the next release.                                     *                                   
 *                                                                        *
 * This program is a part of work in the Perpetuum Mobile Procura project.*
 * URL: http://www.sce.carleton.ca/netmanage/perpetuum.shtml.             *
 *                                                                        * 
 * Copyright 1997, Gatot Susilo                                           *
 * Department of Systems and Computer Engineering,                        *
 * Carleton University                                                    *
 *                                                                        *
 * Author: Gatot Susilo (susilo@sce.carleton.ca)                          *  
 * Date: October 5, 1997                                                  *
 * Contact Person:                                                        *
 *  Andrzej Bieszczad, Associate Professor, Systems & Computer Engineering*
 *  1125 Colonel By Drive, Carleton University, Ottawa, Canada K1S 5B6    *
 *  Email: andrzej@sce.carleton.ca    Tel:(613)520-5734  Fax:(613)520-5727*
 *  URL: http://www.sce.carleton.ca/faculty/bieszczad.html                *
 **************************************************************************
 *                                NO WARRANTY                             *
 *                                                                        *
 * BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY   *
 * FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN*
 * OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES *
 * PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER       *
 * EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED       *
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE*
 * ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH   *
 * YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL    *
 * NECESSARY SERVICING, REPAIR OR CORRECTION.                             *
 *                                                                        *    
 * IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING  *
 * WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR    *
 * REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR      *
 * DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL   *
 * DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM         *
 * (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED      *
 * INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF *
 * THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER OR*
 * OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 **************************************************************************/
import java.io.*;
import java.net.*;

/**
 * The interface between a Facilitator and the MobileCodeManager.
 * This interface must be implemented by a Facilitiator in order
 * to provide the messaging services expected by the MobileCodeManager.
 */
public interface CommunicationFacilitatorInterface {



public abstract InetAddress getMediatorIP();
public abstract int getMediatorPort();
public abstract int getPort();
/**
 * This method was created by a SmartGuide.
 * @param id String
 * @return boolean
 */
public boolean hasMessages(String id);
public boolean isAvailable();
/**
 * This method was created by a SmartGuide.
 * @param id String
 * @return mct.mediator.Message
 */
public Message peek(String id);
public abstract Message receive(String id);
/**
 * This method was created by a SmartGuide.
 * @return mct.mediator.Message
 * @param id java.lang.String
 * @param timer long
 */
public Message receive(String id, long timer);
public abstract Message[] receiveAll(String id);
/**
 * This method was created by a SmartGuide.
 * @return mct.mediator.Message[]
 * @param id java.lang.String
 * @param timer long
 */
public Message[] receiveAll(String id, long timer);
public abstract boolean send(Message mesg, boolean localOnly);
public abstract boolean sendAsync(Message mesg, boolean localOnly);
public abstract void setMediatorIP(InetAddress IPaddress);
public abstract void setMediatorPort(int port);
public abstract void setPort(int port);
/**
 * This method was created by Tony White.
 * @return boolean
 * @param name java.lang.String
 */
boolean startMbx(String name);
/**
 * This method was created by Tony White.
 * @return boolean
 * @param name java.lang.String
 * @param force boolean
 */
boolean stopMbx(String name, boolean force);
}