package mct.mediator;


/**
 * @(#) RemoteMCDirectory.java	1.0 October-13-1997	Cheryl Schramm
 *
 *  The interface for a remote MobileCodeDirectory, one that maintains
 *  location information about all netlets within a region using
 *  remote observers, one located on each
 *
 *  The methods should be regarded as being divided into two
 *  groups :
 *	Observers : methods to build the directory, and limited
 *		    to remote observers located at each place
 *	Users : methods to query the directory
 */

import java.util.*;
import java.rmi.*;
import mct.users.*;
public interface RemoteMCDirectory extends java.rmi.Remote {



public void addMobileCodeRecordR(MobileCodeRecord mcr, int event, boolean force) throws RemoteException;
public MobileCodeRecord getMobileCodeRecordR(String id) throws RemoteException;
public boolean hasMessagingAccessR(String id) throws RemoteException;
/**
 * This method was created in VisualAge.
 * @return boolean
 */
boolean isAvailable() throws RemoteException;
public Enumeration mobileCodeElementsR() throws RemoteException;
public Enumeration mobileCodeIDsR() throws RemoteException;
public void removeMobileCodeRecordR(String id, int event, boolean force) throws RemoteException;
}