package mct.rmi;


/**
  *@(#)RemoteMCDInvocationServer.java
  */

import java.rmi.*;
import java.rmi.server.UnicastRemoteObject;
import java.util.Hashtable;
import java.io.*;
public class RemoteMCDInvocationServer extends UnicastRemoteObject implements RemoteMCDInvocation {

	// Fields
	private String properties;
	private Hashtable process;



RemoteMCDInvocationServer(String properties) throws java.rmi.RemoteException {
	super();
	this.properties = properties;
	this.process = new Hashtable();
}
public int destroy(String name) throws RemoteException {
	try {
		OutputRedirector p = (OutputRedirector) process.get(name);
		if (p != null) {
			p.destroy();
			process.remove(name);
		} else
			return -2;
	} catch (Throwable ex) {
		ex.printStackTrace();
		return -1;
	}
	return 1;
}
public int execute(String classPath, String name, String properties) throws RemoteException {
	try {
		if (properties == null)
			return -2;
		String cmdLine = "java ";
		if (classPath != null)
			cmdLine = cmdLine + "-classpath " + classPath + " ";
		cmdLine = cmdLine + "mct.NetletDaemon " + properties;
		mct.Console.message(null, cmdLine);
		// Fork a process and redirect its output to the output of this thread
		// Destroy a process with the same name before forking the new process.
		// It does not matter if nothing is there, a return of -2 occurs in that
		// case.
		destroy(name);
		Process proc = Runtime.getRuntime().exec(cmdLine);
		OutputRedirector ior = new OutputRedirector(proc);
		process.put(name, ior);
	} catch (Throwable ex) {
		ex.printStackTrace();
		return -1;
	}
	return 1;
}
public static void main(String args[]) {
	// Create and install the security manager
	mct.Console.message(null, "Install RMISecurityManager");
	System.setSecurityManager(new RMISecurityManager());
	try {
		mct.Console.message(null, "Invoke server...");
		RemoteMCDInvocationServer obj = new RemoteMCDInvocationServer("mct/v1.0/conf/netletdaemon01.properties-nosecurity");
		mct.Console.message(null, "Rebind server...");
		Naming.rebind("MCDServer", obj);
		mct.Console.message(null, "RemoteMCDInvocationServer created and bound in the registry to the name MCDServer");
	} catch (Exception e) {
		mct.Console.message(null, "RemoteMCDInvocationServer.main: an exception occurred:");
		e.printStackTrace();
	}
}
public void printHello() throws RemoteException {
	System.out.println("Just printing Hello");
}
}