package mct.users;


/**
 * @(#)Extlet.java	1.0 13-Jun-1997	Gatot Susilo
 */
/**************************************************************************
 *                    COPYRIGHT of MOBILE CODE TOOLKIT                    *
 *                                                                        *
 * This program is a free software and follows terms and conditions as    *
 * described on the GNU General Public License                            *
 * (see http://www.sce.carleton.ca/netmanage/gatot/gpl.html).             *
 * This software is freely distributed; however we recommend that         *
 * everybody should download a free copy directly from our site           *
 * http://www.sce.carleton.ca/netmanage/gatot.                            *
 * Therefore, we can keep a track who has got a copy and what for what    *
 * the purpose is. This will allow us to notify you when there are changes* 
 * or bugs fixed on the next release.                                     *                                   
 *                                                                        *
 * This program is a part of work in the Perpetuum Mobile Procura project.*
 * URL: http://www.sce.carleton.ca/netmanage/perpetuum.shtml.             *
 *                                                                        * 
 * Copyright 1997, Gatot Susilo                                           *
 * Department of Systems and Computer Engineering,                        *
 * Carleton University                                                    *
 *                                                                        *
 * Author: Gatot Susilo (susilo@sce.carleton.ca)                          *  
 * Date: October 5, 1997                                                  *
 * Contact Person:                                                        *
 *  Andrzej Bieszczad, Associate Professor, Systems & Computer Engineering*
 *  1125 Colonel By Drive, Carleton University, Ottawa, Canada K1S 5B6    *
 *  Email: andrzej@sce.carleton.ca    Tel:(613)520-5734  Fax:(613)520-5727*
 *  URL: http://www.sce.carleton.ca/faculty/bieszczad.html                *
 **************************************************************************
 *                                NO WARRANTY                             *
 *                                                                        *
 * BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY   *
 * FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN*
 * OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES *
 * PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER       *
 * EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED       *
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE*
 * ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH   *
 * YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL    *
 * NECESSARY SERVICING, REPAIR OR CORRECTION.                             *
 *                                                                        *    
 * IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING  *
 * WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR    *
 * REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR      *
 * DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL   *
 * DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM         *
 * (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED      *
 * INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF *
 * THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER OR*
 * OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 **************************************************************************/
import java.net.InetAddress;
import java.util.Enumeration;
import mct.admin.MobileCodeStub;
import mct.admin.StorageManager;
import mct.admin.MobileCodeManager;
import mct.admin.MobileCodeContainer;
import mct.admin.MCTEventMulticaster;
import java.util.Random;

/**
 * <h2>This is a sample of mobile code's template, 
 * you may write your own template of mobile code</h2>
 * The Extlet is one of particular types of mobile code that is used 
 * to extend the functionality of the daemon. 
 * The Extlet implements MobileCode (basic), Callback, Parameters,
 * MCDExtension. <p>
 * If you want to write a Deglet, a Servlet that extends the functionality
 * of the daemon; then you should extend this class.<p>
 *
 * @author Gatot Susilo
 * @see java.lang.Runnable
 * @see mct.users.MobileCode
 * @see mct.users.Callback
 * @see mct.users.Parameters
 * @see mct.users.MCDExtension
 * @version 1.0, July 1, 1997
 * @since   MCT1.0
 */

public class Extlet extends MobileCodeObject implements MobileCode, Parameters, MCDExtension {



/**
   * Add a JAR into the MobileCodeContainer of the running mobile code.
   * This is usefull when you want to load more classes that are required
   * by your mobile code.<br>
   * When a JAR is added, it will be verified if the security is enabled.<p>
   * Note: this is not dynamically class loader, but you can anticipate 
   * what classes are going to be needed and you can install it beforehand.
   */
public void addJAR(String name, byte bytes[]) {
	if (stub != null)
		stub.addJAR(name, bytes);
}
/**
   * @see mct.users.Callback#destroy
   */
public void destroy() {
	if (stub != null)
		stub.destroy();
}
public MCTEventMulticaster getEventDispatcher() {
	if (stub != null)
		return stub.getEventDispatcher();
	return null;
}
/**
   * It returns the MobileCodeContainer handle of the running mobile code.
   * If you add/modify JARs on the MobileCodeContainer, you should
   * call method verifyMobileCodeContainer() to see the classes' changes.
   */
public MobileCodeContainer getMobileCodeContainer() {
	if (stub == null)
		return null;
	return stub.getMobileCodeContainer();
}
/**
   * Return the StorageManager handler.<p>
   *
   * Only authorized users (i.e., mobile code that signed by proper
   * signer) can access this method.
   * @throw SecurityException if the users are not authorized
   */
public Object getMobileCodeManager() {
	if (stub != null)
		return stub.getMobileCodeManager();
	return null;
}
// Implementing interface Parameters
/**
   * Return the parameter value of given name if it exists otherwise
   * return null.
   * @param name The name of parameter
   */
public Object getParameter(Object name) {
	//System.out.println ("Stub: "+stub+" Getting the parameter: "+name);
	if (stub != null)
		return stub.getParameter(name);
	return null;
}
/**
   * Return the keys of parameter
   */
public Enumeration getParameterNames() {
	if (stub != null)
		return stub.getParameterNames();
	return null;
}
/**
   * Return all the parameter values.
   */
public Enumeration getParameterValues() {
	if (stub != null)
		return stub.getParameterValues();
	return null;
}
// Implementing interface MCDExtension
/**
   * Get the MoibileCodeManager handler of the Netlet Daemon,
   * hence the extension can control every instant of 
   * incoming packages.<p>
   *
   * Only authorized users (i.e., mobile code that signed by proper
   * signer) can access this method.
   * @return MobileCodeManager; you have to cast it with MobileCodeManager.
   * @throw SecurityException if the users are not authorized
   */
public StorageManager getStorageManager() {
	if (stub != null)
		return stub.getStorageManager();
	return null;
}
/**
   * Return the type of the mobile code. This case is Netlet.
   */
final public String getType() {
	return "EXTLET";
}
/**
   * @see mct.users.Callback#init
   */
public void init() {
	if (stub != null)
		stub.init();
}
/**
   * This allows the mobile code implementing this interface to install
   * another mobile code.
   */
public void instantiate(MobileCodeContainer mcc) {
	if (stub != null)
		stub.instantiate(mcc);
}
// Implementing interface Callback
/**
   * Return true if the netlet is started.
   * @see mct.users.Callback#isActive
   */
public boolean isActive() {
	if (stub != null)
		return stub.isActive();
	return false;
}
/**
   * Cleans up whatever resources are being held. If the 
   * Netlet is active, it is stopped
   * @see #init
   * @see #start
   * @see #stop
   */
public void onDestroy() {
}
/**
   * This method will be called instead of onRestore, when
   * the Netlet is created. (not from deserialization)
   * @see mct.users.Callback#onInit
   */
public boolean onInit() {
	return isInitialized();
}
/**
   * This method will be called instead of onInit, when the 
   * Netlet is deserialized
   * @see mct.users.Callback#onRestore
   */
public void onRestore() {
}
/**
   * The Netlet will be started and marked as active
   * @see mct.users.Callback#onStart
   */
public void onStart() {
}
/**
   * The Netlet will be stopped and marked as not active
   * @see mct.users.Callback#onStop
   */
public void onStop() {
}
/**
   * Put a parameter. It is usefull when a netlet wants to keep track
   * its state or its data that will be used on the next
   * visited agent daemon.
   * @param name the name of parameter
   * @param value the value of parameter
   * @return true if successfull and false otherwise
   */
public void putParameter(Object name, Object value) {
	if (stub != null)
		stub.putParameter(name, value);
}
/**
   * Remove the parameter whose name is specified.
   */
public Object removeParameter(Object name) {
	if (stub != null)
		return stub.removeParameter(name);
	return null;
}
/**
   * @see mct.users.Callback#restore
   */
public void restore() {
	if (stub != null)
		stub.restore();
}
/**
   * @see mct.users.Callback#start
   */
public void start() {
	if (stub != null)
		stub.start();
}
/**
   * @see mct.users.Callback#stop
   */
public void stop() {
	if (stub != null)
		stub.stop();
}
/**
   * Return true if the mobile code container is successfully verified;
   * otherwise return false.
   */
public boolean verifyMobileCodeContainer() {
	if (stub == null)
		return false;
	return stub.verifyMobileCodeContainer();
}
}