package mct.users;


/**
 * @(#)MCDInterface.java	28-Sug-98 Tony White
 */
/**************************************************************************
 *                    COPYRIGHT of MOBILE CODE TOOLKIT                    *
 *                                                                        *
 * This program is a free software and follows terms and conditions as    *
 * described on the GNU General Public License                            *
 * (see http://www.sce.carleton.ca/netmanage/gatot/gpl.html).             *
 * This software is freely distributed; however we recommend that         *
 * everybody should download a free copy directly from our site           *
 * http://www.sce.carleton.ca/netmanage/gatot.                            *
 * Therefore, we can keep a track who has got a copy and what for what    *
 * the purpose is. This will allow us to notify you when there are changes* 
 * or bugs fixed on the next release.                                     *                                   
 *                                                                        *
 * This program is a part of work in the Perpetuum Mobile Procura project.*
 * URL: http://www.sce.carleton.ca/netmanage/perpetuum.shtml.             *
 *                                                                        * 
 * Copyright 1997, Gatot Susilo                                           *
 * Department of Systems and Computer Engineering,                        *
 * Carleton University                                                    *
 *                                                                        *
 * Author: Gatot Susilo (susilo@sce.carleton.ca)                          *  
 * Date: October 5, 1997                                                  *
 * Contact Person:                                                        *
 *  Andrzej Bieszczad, Associate Professor, Systems & Computer Engineering*
 *  1125 Colonel By Drive, Carleton University, Ottawa, Canada K1S 5B6    *
 *  Email: andrzej@sce.carleton.ca    Tel:(613)520-5734  Fax:(613)520-5727*
 *  URL: http://www.sce.carleton.ca/faculty/bieszczad.html                *
 **************************************************************************
 *                                NO WARRANTY                             *
 *                                                                        *
 * BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY   *
 * FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN*
 * OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES *
 * PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER       *
 * EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED       *
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE*
 * ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH   *
 * YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL    *
 * NECESSARY SERVICING, REPAIR OR CORRECTION.                             *
 *                                                                        *    
 * IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING  *
 * WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR    *
 * REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR      *
 * DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL   *
 * DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM         *
 * (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED      *
 * INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF *
 * THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER OR*
 * OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 **************************************************************************/
import mct.admin.StorageManager;
import mct.admin.MobileCodeContainer;
import mct.admin.MCTEventMulticaster;

/**
 * One of the building components of mobile code that involves the 
 * mobile code daemon. This component is typically used for extending
 * the MobileCodeDaemon in functionality.
 *
 * @version 1.0 02-September-1997
 * @author  Gatot Susilo
 * 
 */
public interface MCDInterface {



/**
   * This allows the mobile code implementing this interface to install
   * another mobile code.<br>
   * Fill with: <br>
   *  if (stub==null) return;<br> 
   *  stub.instantiate (mcc);<br>
   * @param mcc the container of mobile code to be instantiated.
   */

/**
   * The EventDispatcher is the user's window inside the MobileCodeManager
   * with respect to the life cycle of netlets
   *
   */
public abstract MCTEventMulticaster getEventDispatcher() throws SecurityException;
/**
   * It returns the MobileCodeContainer handle of the running mobile code.
   * If you add/modify JARs on the MobileCodeContainer, you should
   * call method verifyMobileCodeContainer() to see the classes' changes.<p>
   * Fill with:<br>
   *  if (stub==null) return null;<br>
   *  return stub.getMobileCodeContainer();<br>
   */
public abstract MobileCodeContainer getMobileCodeContainer();
/**
   * Get the MobileCodeManager handler of the Netlet Daemon,
   * hence the extension can control every instant of 
   * incoming packages.<p>
   *
   * Only authorized users (i.e., mobile code that signed by proper
   * signer) can access this method.<p>
   *
   * Fill with:<br>
   *  if (stub==null) return null;<br>
   *  return stub.getMobileCodeManager();<br>
   *
   * @return MobileCodeManager; you have to cast it with MobileCodeManager.
   * @throw SecurityException if the users are not authorized
   */

public abstract Object getMobileCodeManager() throws SecurityException;
/**
   * Return the StorageManager handler.<p>
   *
   * Only authorized users (i.e., mobile code that signed by proper
   * signer) can access this method.<p>
   *
   * Fill with:<br>
   *  if (stub==null) return null;<br>
   *  return stub.getStorageManager();<br>
   *
   * @throw SecurityException if the users are not authorized
   */
public abstract StorageManager getStorageManager() throws SecurityException;
}