package mct.users;


import java.io.Serializable;
/**
 * This class was generated by a SmartGuide.
 * This class allows an identifier to be associated with mobile code.
 * An identifier consists of (currently) two components: a name
 * which is user-specified and can be any character string which does
 * not contain the delimeter and a class name which is used to 
 * instantiate the mobile code.
 * 
 */
public class MCIdentifier implements Serializable {
	private final String name;
	private final String className;
	private String authority;
	public static final String delimeter = "@";
	public static final String[] authDelimeter = {"[", "]"};
	private static final String _authority = "PUBLIC";



/**
 * This method was created by a SmartGuide.
 * @param id java.lang.String
 */
public MCIdentifier(String id) {
	this.name = MCIdentifier.getNameFromIdentifier(id);
	this.className = MCIdentifier.getClassFromIdentifier(id);
	this.authority = MCIdentifier.getAuthorityFromIdentifier(id);
}
/**
 * This method was created by a SmartGuide.
 * @param id java.lang.String
 * @param className java.lang.String
 */
public MCIdentifier(String id, String className) {
	this.name = id;
	this.className = className;
	this.authority = defaultAuthority();
}
/**
 * This method was created in VisualAge.
 * @param name java.lang.String
 * @param className java.lang.String
 * @param authority java.lang.String
 */
public MCIdentifier(String name, String className, String authority) {
	this.name = name;
	this.className = className;
	this.authority = authority;
}
/**
 * This method was created by a SmartGuide.
 * @param className java.lang.String
 * @param allocate boolean
 */
public MCIdentifier(String className, boolean allocate) {
	if (!allocate)
		this.name = null;
	else
		this.name = UniqueID.create("MCID");
	this.className = className;
	this.authority = defaultAuthority();
}
/**
 * This method was created by a SmartGuide.
 * @return java.lang.String
 */
public final static String defaultAuthority() {
	return _authority;
}
/**
 * This method was created by a SmartGuide.
 * @return java.lang.String
 */
public final String getAuthority() {
	return authority;
}
/**
 * This method breaks out the authority field from a String
 * @return java.lang.String
 */
public static String getAuthorityFromIdentifier(String identifier) {
	if (identifier == null)
		return null;

	int sIndex = -1;
	int eIndex = -1;
	for (int i = 0; i < identifier.length(); i++)
		if (identifier.charAt(i) == authDelimeter[0].charAt(0)) {
			sIndex = i;
			break;
		}
	// No authority, so return the default.	
	if (sIndex == -1)
		return _authority;	
	for (int i = sIndex+1; i < identifier.length(); i++)	
		if (identifier.charAt(i) == authDelimeter[1].charAt(0)) {
			eIndex = i;
			break;
		}	
	// User partially defined an authority but forgot the closing
	// square bracket.
	if (eIndex == -1)
		return null;
			
	return identifier.substring(sIndex + 1, eIndex);
}
/**
 * This method breaks out the class from the identifier.
 * If neither name nor authority are provided, the whole
 * string is assumed to be the class name.
 * 
 * @param identifier java.lang.String
 * @return java.lang.String
 */
public static String getClassFromIdentifier(String identifier) {
	if (identifier == null)
		return null;
	int sIndex = -1;
	int eIndex = identifier.length();
	for (int i = 0; i < identifier.length(); i++)
		if (identifier.charAt(i) == delimeter.charAt(0)) {
			sIndex = i;
			break;
		}
	// If the delimeter is not found it means that the identifier
	// is the class. A default authority will be applied to this 
	// identifier.
	if (sIndex == -1)
		return new String(identifier);
	else
		return identifier.substring(sIndex+1);
}
/**
 * This method was created by a SmartGuide.
 * @return java.lang.String
 */
public final String getClassName() {
	return className;
}
/**
 * This method was created by a SmartGuide.
 * @return java.lang.String
 */
public final String getID() {
	if (name == null)
		return className;
	else
		return name + authDelimeter[0] + authority + authDelimeter[1] + delimeter + className;
}
/**
 * This method was created by a SmartGuide.
 * @return java.lang.String
 */
public final String getName() {
	return name;
}
/**
 * This method breaks out the name from the String.
 * If neither class nor authority fields are present,
 * null is returned.
 * 
 * @param identifier java.lang.String
 * @return java.lang.String
 */
public static String getNameFromIdentifier(String identifier) {
	if (identifier == null)
		return null;

	int eIndex = -1;
	for (int i = 0; i < identifier.length(); i++) {
		if (identifier.charAt(i) == authDelimeter[0].charAt(0)) {
			eIndex = i;
			break;
		}
		// End of authority without start - ERROR
		if (identifier.charAt(i) == authDelimeter[1].charAt(0)) {
			return null;
		}
		if (identifier.charAt(i) == delimeter.charAt(0)) {
			eIndex = i;
			break;
		}
	}	
	if (eIndex == -1)
		return null;	
	return identifier.substring(0, eIndex);
}
/**
 * This method was created by a SmartGuide.
 * @return java.lang.String
 * @param authority java.lang.String
 */
public final String setAuthority(String authority) {
	return this.authority = authority;
}
/**
 * This method was created by a SmartGuide.
 * @return java.lang.String
 */
public String toString() {
	return getID();
}
}