package mct.users;


/**
 * This class was generated by a SmartGuide.
 * 
 */
import mct.users.MobileCode;
import mct.admin.MobileCodeStub;
import java.util.Enumeration;
import java.util.Properties;
import mct.users.MCIdentifier;
import mct.users.Parameters;
public class MobileCodeObject implements java.io.Serializable {
	private MCIdentifier identifier;
	// Declare the interface stub as transient in order to avoid it
	// being serialized when written out.
	public transient MobileCodeStub stub = null;
	private String info = "";
	private int eventNumber = mct.mediator.MobileCodeDirectory.MCD_FORCE;



/**
 * This method was created by a SmartGuide.
 * @return boolean
 */
final public boolean destroyThread() {
	if (hasThread()) {
		getStub().destroy();
		return true;
	}
	return false;
}
/**
   * Return the alias name of netlet.
   */
public String getAlias() {
	return this.getClass().getName();
}
/**
 * This method was created by a SmartGuide.
 * @return int
 */
public int getEventNumber() {
	return eventNumber;
}
/**
   * Return the unique ID of the netlet, creating one randomly 
   * if necessary. Uses lazy evaluation for the creation of identifiers.
   */
public String getID() {
	if (identifier == null) {
		identifier = new MCIdentifier(getType(), true);
	}
	return getIdentifier().getID();
}
/**
 * This method was created by a SmartGuide.
 * @return mct.users.MCIdentifier
 */
public final MCIdentifier getIdentifier() {
	return identifier;
}
/**
   * Return the description about the netlet.
   */
public String getInfo() {
	return info;
}
/**
   * Returns MobileCodeStub handler to allow subclass of the Netlet to access the
   * stub handler.
   */
final public MobileCodeStub getStub() {
	return stub;
}
/**
 * This method was created by a SmartGuide.
 * This method is provided in order to provide a default 
 * implementation of the MobileCode interface. It will, however,
 * generally be overloaded.
 *
 * @return java.lang.String
 */
public String getType() {
	return "MobileCode";
}
/**
 * This method was created by a SmartGuide.
 * @return boolean
 */
final public boolean hasThread() {
	return getStub().hasThread();
}
/**
 * This method was created by a SmartGuide.
 * @return boolean
 */
final public boolean isInitialized() {
	return stub != null;
}
/**
 * This method decrements the event counter
 * @return int
 */
public int lastEvent() {
	return --eventNumber;
}
/**
 * This method increments the event counter
 * @return int
 */
public int nextEvent() {
	return ++eventNumber;
}
/**
   * Performs initialization of the mobile code parameters,
   * with full access to any MobileCodeStub methods
   *
   * @returns	True if no initialization errors encountered
   *		False if initialization error happened that will
   *		prevent the running of this mobile Code
   */
public boolean onInit() {
	// Using waitInit() here is probably a better initialization
	// method as it will ensure that we have a stub.
	return isInitialized();
}
/**
   * Performs initialization of the mobile code parameters,
   * with full access to any MobileCodeStub methods
   *
   * @param	properties 	An optional property file used only
   *				during startup of a MobileCodeDaemon
   *				in which parameter values are available
   * @returns	True if no initialization errors encountered
   *		False if initialization error happened that will
   *		prevent the running of this mobile Code
   */
public boolean onInit(java.util.Properties properties) {
	if (properties != null) {
		if (this instanceof Parameters) {
			for (Enumeration e = properties.propertyNames(); e.hasMoreElements();) {
				String name = (String) e.nextElement();
				((Parameters) this).putParameter(name, properties.getProperty(name));
			}
		}
	}
	return onInit();
}
/**
 * This method resets the event number for the mobile code object
 * @return int
 */
public int resetEventNumber() {
	return eventNumber = mct.mediator.MobileCodeDirectory.MCD_FORCE;
}
/**
 * This method was created by a SmartGuide.
 * @return boolean
 */
final public boolean resumeThread() {
	if (hasThread()) {
		getStub().resume();
		return true;
	}
	return false;
}
/**
 * This method was created by a SmartGuide.
 * @return mct.users.MCIdentifier
 */
public final MCIdentifier setIdentifier(MCIdentifier identifier) {
	return this.identifier = identifier;
}
/**
 * This method was created by a SmartGuide.
 * @return java.lang.Object
 * @param inf java.lang.String
 */
public final String setInfo(String info) {
	return this.info = info;
}
//Implementing interface MobileCode
/**
   * This is called automatically during the first time an Netlet is created.
   * It should be called by the mobile code manager, not another piece of 
   * mobile code.
   */
final public void setStub(MobileCodeStub stub) {
	if (this.stub == null)
		this.stub = stub;
}
/**
 * This method was created by a SmartGuide.
 * @return boolean
 */
final public boolean startThread() {
	if (!hasThread()) {
		getStub().start();
		return true;
	}
	return false;
}
/**
 * This method was created by a SmartGuide.
 * @return boolean
 */
final public boolean stopThread() {
	if (hasThread()) {
		getStub().stop();
		return true;
	}
	return false;
}
/**
 * This method was created by a SmartGuide.
 * @return boolean
 */
final public boolean suspendThread() {
	if (hasThread()) {
		getStub().suspend();
		return true;
	}
	return false;
}
/**
 * This method was created by a SmartGuide.
 * This method ensures that the mobileCodeObject has been
 * successfully set up by the mobileCodeManager before
 * proceeding with execution.
 */
final public void waitInit() {
	while (!isInitialized()) {
		Thread.yield();
	};
	return;
}
}