package mct.users;


/**
 * @(#)Netlet.java	1.0 13-Nov-1996	Gatot Susilo
 */
/**************************************************************************
 *                    COPYRIGHT of MOBILE CODE TOOLKIT                    *
 *                                                                        *
 * This program is a free software and follows terms and conditions as    *
 * described on the GNU General Public License                            *
 * (see http://www.sce.carleton.ca/netmanage/gatot/gpl.html).             *
 * This software is freely distributed; however we recommend that         *
 * everybody should download a free copy directly from our site           *
 * http://www.sce.carleton.ca/netmanage/gatot.                            *
 * Therefore, we can keep a track who has got a copy and what for what    *
 * the purpose is. This will allow us to notify you when there are changes* 
 * or bugs fixed on the next release.                                     *                                   
 *                                                                        *
 * This program is a part of work in the Perpetuum Mobile Procura project.*
 * URL: http://www.sce.carleton.ca/netmanage/perpetuum.shtml.             *
 *                                                                        * 
 * Copyright 1997, Gatot Susilo                                           *
 * Department of Systems and Computer Engineering,                        *
 * Carleton University                                                    *
 *                                                                        *
 * Author: Gatot Susilo (susilo@sce.carleton.ca)                          *  
 * Date: October 5, 1997                                                  *
 * Contact Person:                                                        *
 *  Andrzej Bieszczad, Associate Professor, Systems & Computer Engineering*
 *  1125 Colonel By Drive, Carleton University, Ottawa, Canada K1S 5B6    *
 *  Email: andrzej@sce.carleton.ca    Tel:(613)520-5734  Fax:(613)520-5727*
 *  URL: http://www.sce.carleton.ca/faculty/bieszczad.html                *
 **************************************************************************
 *                                NO WARRANTY                             *
 *                                                                        *
 * BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY   *
 * FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN*
 * OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES *
 * PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER       *
 * EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED       *
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE*
 * ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH   *
 * YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL    *
 * NECESSARY SERVICING, REPAIR OR CORRECTION.                             *
 *                                                                        *    
 * IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING  *
 * WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR    *
 * REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR      *
 * DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL   *
 * DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM         *
 * (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED      *
 * INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF *
 * THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER OR*
 * OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 **************************************************************************/
import java.net.InetAddress;
import java.util.Enumeration;
import mct.admin.MobileCodeStub;
import java.io.Serializable;
import java.util.Random;

/**
 * <h2>This is a sample of mobile code's template, 
 * you may write your own template of mobile code</h2>
 * The Netlet is one of particular types of mobile code that is used 
 * to do most the jobs. It typically accesses VMCs installed on the daemon
 * to performs its tasks. It can also migrate/travel from one daemon to the next.
 * The Netlet implements MobileCode (basic), Callback, Parameters, Migratable,
 * and VMCAccess. <p>
 *
 * @author Gatot Susilo
 * @see java.lang.Runnable
 * @see mct.users.MobileCode
 * @see mct.users.Callback
 * @see mct.users.Parameters
 * @see mct.users.MCDExtension
 * @version 1.0, July 1, 1997
 * @since   MCT1.0
 */
public class Netlet extends MobileCodeObject implements MobileCode, Parameters, Migratable, VMCAccess {



/**
   * @see mct.users.Callback#destroy
   */
public void destroy() {
	if (stub != null)
		stub.destroy();
}
/**
   * Get the list of name of managed object handler.
   * @see RMIMobileCodeManager#getMigrationDestinations
   */
public java.net.URL[] getMigrationDestinations() {
	if (stub != null)
		return stub.getMigrationDestinations();
	return null;
}
// Implementing interface Parameters
/**
   * Return the parameter value of given name if it exists otherwise
   * return null.
   * @param name The name of parameter
   */
public Object getParameter(Object name) {
	if (stub != null)
		return stub.getParameter(name);
	return null;
}
/**
   * Return the keys of parameter
   */
public Enumeration getParameterNames() {
	if (stub != null)
		return stub.getParameterNames();
	return null;
}
/**
   * Return all the parameter values.
   */
public Enumeration getParameterValues() {
	if (stub != null)
		return stub.getParameterValues();
	return null;
}
/**
   * Return the type of the mobile code. This case is Netlet.
   */
final public String getType() {
	return "NETLET";
}
// Implementing interface VMCAccess
/**
   * Get the virtual managed component handler whose name is specified in
   * the parameter.
   * @param name name of object handler
   * @see #getVirtualManagedComponentList
   */
public MobileCodeObject getVirtualManagedComponent(String name, boolean className) {
	if (stub != null)
		return stub.getVirtualManagedComponent(name, className);
	return null;
}
/**
   * Get the list of name of managed object handler.
   * @see #getVirtualManagedComponent
   */
public Enumeration getVirtualManagedComponentList() {
	if (stub != null)
		return stub.getVirtualManagedComponentList();
	return null;
}
/**
   * @see mct.users.Callback#init
   */
public void init() {
	if (stub != null)
		stub.init();
}
// Implementing interface Callback
/**
   * Return true if the netlet is started.
   * @see mct.users.Callback#isActive
   */
public boolean isActive() {
	if (stub != null)
		return stub.isActive();
	return false;
}
/**
   * Request the agent daemon to migrate the netlet to
   * the destination specified by the netlet itself either
   * via TCP (tcp=true) or via UDP (tcp=false)
   */
public void migrate(String name, InetAddress ip, int port, boolean flag) {
	if (stub != null)
		stub.migrate(name, ip, port, flag);
}
/**
   * Request the agent daemon to migrate the netlet to
   * the destination specified by the agent daemon 
   * either via TCP (tcp=true) or via UDP (tcp=false)
   */
public void migrate(String name, boolean flag) {
	if (stub != null)
		stub.migrate(name, flag);
}
/**
   * Request the agent daemon to migrate the netlet to
   * the destination specified by the netlet itself either
   * via TCP (tcp=true) or via UDP (tcp=false)
   */
public void migrate(MobileCodeObject mobileCode, InetAddress ip, int port, boolean flag) {
	if (stub != null)
		stub.migrate(mobileCode, ip, port, flag);
}
public void migrate(MobileCodeObject mobileCode, InetAddress ip, MCIdentifier destination) {
	if (stub != null)
		stub.migrate(mobileCode, ip, destination);
}
// Implementing interface Migratable
/**
   * Request the agent daemon to migrate the netlet to
   * the destination specified by the agent daemon 
   * either via TCP (tcp=true) or via UDP (tcp=false)
   */
public void migrate(MobileCodeObject mobileCode, boolean flag) {
	if (stub != null)
		stub.migrate(mobileCode, flag);
}
/**
   * Cleans up whatever resources are being held. If the 
   * Netlet is active, it is stopped
   * @see #init
   * @see #start
   * @see #stop
   */
public void onDestroy() {
}
/**
   * When the migration fails for some reasons, this method
   * will be called. Therefore, the netlet can decide what
   * to do next.
   */
public void onFailMigrate(InetAddress ip, int port, boolean isTCP) {
	System.out.println("The migration to " + ip + " port " + port + " via " + (isTCP ? "TCP" : "UDP") + " has failed.");
}
/**
   * This method will be called when the mobile code is just about migrated.
   */
public int onMigrate() {
	if (this instanceof Serializable)
		return SERIALIZE; // DONT_MIGRATE, SERIALIZE, DONT_SERIALIZE, 
	return DONT_SERIALIZE;
}
/**
   * This method will be called instead of onInit, when the 
   * Netlet is deserialized. By default, it does the same as onInit()
   * @see mct.users.Callback#onRestore
   */
public boolean onRestore() {
	return onInit();
}
/**
   * The Netlet will be started and marked as active
   * @see mct.users.Callback#onStart
   */
public void onStart() {
}
/**
   * The Netlet will be stopped and marked as not active
   * @see mct.users.Callback#onStop
   */
public void onStop() {
}
/**
   * Put a parameter. It is usefull when a netlet wants to keep track
   * its state or its data that will be used on the next
   * visited agent daemon.
   * @param name the name of parameter
   * @param value the value of parameter
   * @return true if successfull and false otherwise
   */
public void putParameter(Object name, Object value) {
	if (stub != null)
		stub.putParameter(name, value);
}
/**
   * Remove the parameter whose name is specified.
   */
public Object removeParameter(Object name) {
	if (stub != null)
		return stub.removeParameter(name);
	return null;
}
/**
   * @see mct.users.Callback#restore
   */
public void restore() {
	if (stub != null)
		stub.restore();
}
/**
   * @see mct.users.Callback#start
   */
public void start() {
	if (stub != null)
		stub.start();
}
/**
   * @see mct.users.Callback#stop
   */
public void stop() {
	if (stub != null)
		stub.stop();
}
}