package mct.users;


/**
 * This class was generated by a SmartGuide.
 * 
 */
import java.lang.reflect.*;
public class Receiver {
	private Object object;
	private Method method;



/**
 * This method was created by a SmartGuide.
 * @param object java.lang.Object
 * @param method java.lang.reflect.Method
 */
public Receiver(Object object, Method method) {
	// Assume that the method is associated with the behavior of the object.
	// We could check, but the invoke will always throw an exception.
	this.method = method;
	this.object = object;
}
/**
 * This method was created by a SmartGuide.
 * @param object java.lang.Object
 * @param methodName java.lang.String
 * @param parameterTypes java.lang.Class[]
 */
public Receiver(Object object, String methodName, Class[] parameterTypes) {
	try {
		this.method = object.getClass().getMethod(methodName, parameterTypes);
		this.object = object;
	} catch (java.lang.NoSuchMethodException ex) {
		this.method = null;
		this.object = null;
	}
}
/**
 * This method was created by a SmartGuide.
 * @return boolean
 * @param receiver mct.users.Receiver
 */
public boolean equals(Receiver receiver) {
	if (!(object.equals(receiver.getObject())))
		return false;
	if (receiver.getMethod() == null || method == null)
		return true;
	if (method.equals(receiver.getMethod()))
		return true;
	return false;
}
/**
 * This method was created by a SmartGuide.
 * @return java.lang.reflect.Method
 */
public Method getMethod() {
	return method;
}
/**
 * This method was created by a SmartGuide.
 * @return java.lang.Object
 */
public Object getObject() {
	return object;
}
/**
 * This method was created by a SmartGuide.
 * @param parameters java.lang.Object[]
 */
public void invoke(Object[] parameters) throws java.lang.IllegalAccessException, java.lang.reflect.InvocationTargetException {
	Class[] parameterTypes = method.getParameterTypes();
	int size1 = Array.getLength(parameters);
	int size2 = Array.getLength(parameterTypes);
	if (size1 != size2)
		return;
	else {
		for (int i = 0; i < size1; i++) {
			if (!(parameterTypes[i].isInstance(parameters[i])))
				return;
		}
	}
	method.invoke(object, parameters);
	return;
}
/**
 * This method was created by a SmartGuide.
 * @param parameter java.lang.Object
 */
public void invoke(Object parameter) throws java.lang.IllegalAccessException, java.lang.reflect.InvocationTargetException {
	Class[] parameterTypes = method.getParameterTypes();
	if (parameterTypes.length != 1)
		return;
	if (!(parameterTypes[0].isInstance(parameter)))
		return;
	Object[] parameters = new Object[1];
	parameters[0] = parameter;
	method.invoke(object, parameters);
	return;
}
/**
 * This method was created by a SmartGuide.
 * @param parameter java.lang.Object
 */
public void invoke(Object parameter1, Object parameter2) throws java.lang.IllegalAccessException, java.lang.reflect.InvocationTargetException {
	Class[] parameterTypes = method.getParameterTypes();
	if (parameterTypes.length != 2)
		return;
	if (!(parameterTypes[0].isInstance(parameter1)))
		return;
	if (!(parameterTypes[1].isInstance(parameter2)))
		return;
	Object[] parameters = new Object[2];
	parameters[0] = parameter1;
	parameters[1] = parameter2;
	method.invoke(object, parameters);
	return;
}
/**
 * This method was created by a SmartGuide.
 * @param parameter java.lang.Object
 */
public void invoke(Object parameter1, Object parameter2, Object parameter3) throws java.lang.IllegalAccessException, java.lang.reflect.InvocationTargetException {
	Class[] parameterTypes = method.getParameterTypes();
	if (parameterTypes.length != 3)
		return;
	if (!(parameterTypes[0].isInstance(parameter1)))
		return;
	if (!(parameterTypes[1].isInstance(parameter2)))
		return;
	if (!(parameterTypes[2].isInstance(parameter3)))
		return;
	Object[] parameters = new Object[3];
	parameters[0] = parameter1;
	parameters[1] = parameter2;
	parameters[2] = parameter3;
	method.invoke(object, parameters);
	return;
}
/**
 * This method was created by a SmartGuide.
 * @return java.lang.reflect.Method
 * @param method Method
 */
public Method setMethod(Method method) {
	return this.method = method;
}
/**
 * This method was created by a SmartGuide.
 * @return java.lang.Object
 * @param object Object
 */
public Object setObject(Object object) {
	return this.object = object;
}
/**
 * This method was created by Tony White.
 * @return java.lang.String
 */
public String toString() {
	return object.toString()+"->"+method.toString();
}
}